version 7.0
set matsize 120
tempfile cnaeniv piae cgccnae

capture program drop str2int
program define str2int
    args varname
    local lab : variable label `varname'
    qui gen _`varname' = int(real(subinstr(`varname'," ","",.)))
    drop `varname'
    rename _`varname' `varname'
    label var `varname' "`lab'"
end

foreach yr in 86 87 88 89 90 92 93 94 95 {
    insheet using "brazcomp\ibge\tab1-`yr'.csv", clear
    drop if niv100 < 100
    drop desc
    foreach var in firms employment salaries sales cost profit { str2int `var' }
    drop if firms==.
    rename cost costs
    preserve
        use "brazprod\data\pia-e\piae`yr'", clear
        keep niv100 labftot wagetot sales resales profit
        gen byte firms=1
        rename labftot employment
        rename wagetot salaries
        egen _sales = rsum(sales resales)
        drop sales resales
        rename _sales sales
        order niv100 firms employment salaries sales profit
        foreach var in salaries sales profit { replace `var' = `var'/1000 } 
        sort niv100
        collapse (sum) firms employment salaries sales profit, by(niv100)
        foreach var in salaries sales profit {  replace `var' = int(`var'+.5) }
        compress
        foreach var in niv100 firms employment salaries sales profit { label var `var' "PIA-E `var'" }
        foreach var in firms employment salaries sales profit { rename `var' pia_`var' }
        sort niv100
        save `piae', replace
    restore
    sort niv100
    merge niv100 using `piae'
    drop _merge
    drop if niv100<=199
    sort niv100
    save "brazcomp\data\secagg\tab`yr'", replace
}

foreach yr in 96 97 98 {
    insheet using "brazcomp\ibge\tab1-`yr'.csv", clear
    drop if cnae < 100
    drop cnaedesc
    foreach var in firms employment sales { str2int `var' }
    drop if firms==. | cnae==.
    preserve
        use "brazprod\cgc-list\cgc-cnae-96-98", clear
        keep if year==`yr'
        keep firm cnae
        replace cnae=int(cnae/10)
        sort firm
        save `cgccnae', replace
        use "brazprod\data\pia-e\piae`yr'", clear
        keep firm labftot wagetot sales resales profit
        merge firm using `cgccnae', nokeep
        keep cnae labftot wagetot sales resales profit
        gen byte firms=1
        rename labftot employment
        rename wagetot salaries
        egen _sales = rsum(sales resales)
        drop sales resales
        rename _sales sales
        order cnae firms employment salaries sales profit
        foreach var in salaries sales profit { replace `var' = `var'/1000 } 
        sort cnae
        collapse (sum) firms employment salaries sales profit, by(cnae)
        foreach var in salaries sales profit {  replace `var' = int(`var'+.5) }
        compress
        foreach var in cnae firms employment salaries sales profit { label var `var' "PIA-E `var'" }
        foreach var in firms employment salaries sales profit { rename `var' pia_`var' }
        keep cnae pia_firms pia_employment pia_sales
        sort cnae
        save `piae', replace
    restore
    sort cnae
    merge cnae using `piae'
    drop _merge
    sort cnae
    compress
    save "brazcomp\data\secagg\tab`yr'", replace
}

foreach yr in 99 00 {
    insheet using "brazcomp\ibge\tab1-`yr'.csv", clear
    drop if cnae < 100
    drop cnaedesc
    foreach var in firms employment sales { str2int `var' }
    drop if firms==. | cnae==.
    sort cnae
    compress
    save "brazcomp\data\secagg\tab`yr'", replace
}

