version 6.0
tempfile tmpfrst

/* CGC list with first appearance in sample */
use "brazprod\data\life\firms0-all.dta", clear
gen int first=86 if ano86~=.                        /* First appearance in sample */
replace first=87 if ano87~=. & first==.
replace first=88 if ano88~=. & first==.
replace first=89 if ano89~=. & first==.
replace first=90 if ano90~=. & first==.
replace first=92 if ano92~=. & first==.
replace first=93 if ano93~=. & first==.
replace first=94 if ano94~=. & first==.
replace first=95 if ano95~=. & first==.
replace first=96 if ano96~=. & first==.
replace first=97 if ano97~=. & first==.
replace first=98 if ano98~=. & first==.
gen int repborn=86 if state86==2                    /* First period with state==2 */
replace repborn=87 if state87==2 & repborn==.
replace repborn=88 if state88==2 & repborn==.
replace repborn=89 if state89==2 & repborn==.
replace repborn=90 if state90==2 & repborn==.
replace repborn=92 if state92==2 & repborn==.
replace repborn=93 if state93==2 & repborn==.
replace repborn=94 if state94==2 & repborn==.
replace repborn=95 if state95==2 & repborn==.
replace repborn=96 if state96==2 & repborn==.
replace repborn=97 if state97==2 & repborn==.
replace repborn=98 if state98==2 & repborn==.
keep firm first repborn
sort firm
save `tmpfrst', replace
use "brazprod\data\pia-emp.dta", clear
quietly by firm: keep if _n==_N
keep firm born
sort firm
merge firm using `tmpfrst'
replace first=first+1900
replace repborn=repborn+1900
label var born "From Register (CAD) or Census"
label var first "First Year of Appearance in PIA"
label var repborn "Labeled as Pre-Operation in PIA"
drop _merge

/* Old firm that appears in PIA in 1986 */
gen int manborn=born if born<1986 & first==1986 & (repborn<=born | repborn==.)
label var manborn "Manually assigned date of birth"
gen int catentry=1 if born<1986 & first==1986 & (repborn<=born | repborn==.)
label var catentry "Manual Entry Classification"

/* New and well born firm during sample period */
replace manborn=born if born==first & (repborn<=born | repborn==.)
replace catentry=2 if born==first & (repborn<=born | repborn==.)
replace manborn=born if born==first & first==repborn
replace catentry=2 if born==first & first==repborn

/* Apparently new born firm in PIA, but not reported in cadastro */
replace manborn=first if first==repborn & born==.
replace catentry=3 if first==repborn & born==.         

/* New born firm, but lag before appearance in PIA (<= 3 years) */
replace manborn=born if (born>=first-3 & born<first) & (repborn==. | repborn==first) & catentry~=1
replace catentry=4.1 if born==first-1 & (repborn==. | repborn==first) & catentry~=1
replace catentry=4.2 if born==first-2 & (repborn==. | repborn==first) & catentry~=1
replace catentry=4.3 if born==first-3 & (repborn==. | repborn==first) & catentry~=1

/* Late comer: Old firm that enters PIA after 1986 (foundation > 3 years back) */
replace manborn=born if born<first & repborn==. & catentry==.
replace catentry=7 if born<first & repborn==. & catentry==.

/* Out of the blue: Firm without age (born) or birth (repborn) information */
replace manborn=born if born==. & repborn==.
replace catentry=8 if born==. & repborn==.

/* Strange 1: Firm enters like young but is old */
replace manborn=. if born<first & repborn==first & catentry==.
replace catentry=9.1 if born<first & repborn==first & catentry==.
/* Strange 2: Entry in cadastro later than appearance in PIA */
replace manborn=. if born>first & born~=.
replace catentry=9.2 if born>first &born~=.
/* Strange 3: Born but in installation process long after PIA birth */
replace manborn=. if repborn>first & repborn~=.
replace catentry=9.3 if repborn>first & repborn~=.

/* 
rename firm cgc
rename born nascida
rename first app_pia
rename repborn sit2_pia
*/

format catentry %4.0g
format first repborn manborn %4.0f

sort catentry born first
save "brazprod\data\life\firms-entry.dta", replace
