version 6.0
tempfile main fborn augm appd refer master del firmhd entry exit
use "brazprod\data\pia-finl.dta", clear
/* NOTE: The line "drop pr1num-pr3spnof...  /* If error encountered below: AUGMENT number of generations HERE */" */
/*       was left in this specific way to create an error message if more than 3 generations are identified */
/*       Possible replacement: "drop pr1num=pr`gennumb'spnof... " */

/* Reset to initial state */
replace catlife=9.1 if catlife==float(9.15)
replace catlife=9.3 if catlife==float(9.35)
replace catentry=int(catentry) if int(catentry)==2 | int(catentry)==8
replace catentry=4.1 if catlife==float(4.11) | catlife==float(4.12) | catlife==float(4.13) | catlife==float(4.14) | catlife==float(4.15)
replace catentry=4.2 if catlife==float(4.21) | catlife==float(4.22) | catlife==float(4.23) | catlife==float(4.24) | catlife==float(4.25)
replace catentry=4.3 if catlife==float(4.31) | catlife==float(4.32) | catlife==float(4.33) | catlife==float(4.34) | catlife==float(4.35)
format catentry %4.0g
capture drop econborn
capture drop labfavg
capture drop dpredcgc
capture drop dprchg
capture drop dprborn
capture drop dprextyr
capture drop dprnotex
capture drop dprlfavg
capture drop prednum
capture drop dprabsrb
save `main', replace

preserve
  keep firm effborn labftot catentry
  rename effborn fborn
  rename catentry fcatentr
  egen int flfavg=mean(labftot), by(firm)
  drop labftot
  sort firm
  quietly by firm: keep if _n==1
  save `fborn', replace
restore

/* Create Referencing Dataset, starting with firms that are being referenced by exiters */
/*--------------------------------------------------------------------------------------*/
local round 1
gen byte smplch=1 if state==6 & cgcsuc~=. & change~=10
replace smplch=1 if state==6 & cgcsuc~=. & (year==lastyr | year==effextyr)
replace smplch=1 if state==4 & cgcsuc~=. & change~=10
replace smplch=1 if state==4 & cgcsuc~=. & (year==lastyr | year==effextyr | year==effextyr-1)
replace smplch=1 if (state==8 | state==5) & change==1 & cgcsuc~=.
replace smplch=1 if (state==8 | state==5) & change==2 & cgcsuc~=.
replace smplch=1 if (state==8 | state==5) & change==4 & cgcsuc~=.
replace smplch=1 if (state==8 | state==5) & change==7 & cgcsuc~=.
/* replace smplch=1 if (state==8 | state==5) & change==. & sales==. & cgcsuc~=. */
replace smplch=1 if state==1 & indcor==2 & cgcsuc~=. & year==lastyr & year<98 & change==10
/* Note: change==5 | change==6 left out as they do not result in exit */
/* Note: These selection rules are adapted from "Absorbed firms and mere CGC changers" in analyz-life-emp.do */
gen byte pr`round'notex=1 if catlife==float(9.1)        /* Referencing firm does not exit de facto */
egen int pr`round'lfavg=mean(labftot), by(firm)
drop labftot
keep if smplch==1
keep firm cgcsuc change effborn indnolnk pr`round'notex effextyr year catlife catentry pr`round'lfavg
rename catentry pr`round'entrc
rename catlife pr`round'lifec
rename year pr`round'absrb
rename effextyr pr`round'extyr
format pr`round'extyr pr`round'absrb %4.0f
replace pr`round'extyr=pr`round'extyr+1900
/* replace pr`round'extyr=0 if pr`round'notex==1 */
replace pr`round'absrb=pr`round'absrb+1900
/* replace pr`round'extyr=pr`round'absrb if int(pr`round'lifec)==float(9) | int(pr`round'lifec)==8 */
gen byte pr`round'notlv=1 if pr`round'lifec==float(9.3) /* Referencing firm never alive in PIA */
rename indnolnk fnotlv                                  /* Referenced firm never alive in PIA */
rename firm pr`round'cgc
rename cgcsuc firm
rename change pr`round'chg
rename effborn pr`round'born
egen grp=group(firm pr1cgc)
egen mingrp=min(grp), by(firm)
egen maxgrp=max(grp), by(firm)
sort firm
quietly by firm: gen byte pr1num=maxgrp-mingrp+1
sort grp
quietly by grp: keep if _n==1
drop mingrp maxgrp grp
sort firm pr`round'cgc
drop if firm<99
gen fcorcatl=.
drop if firm==pr1cgc
replace fcorcatl=9.15 if firm==pr1cgc & pr1lifec==float(9.1)
replace fcorcatl=9.35 if firm==pr1cgc & pr1lifec==float(9.3)
label var fnotlv "Referenced Firm Not Alive in PIA"
label var fcorcatl "Corrected Exit Category of Firm"
label var pr`round'notlv "Predecessor 1 Not Alive in PIA"
label var pr`round'notex "Predecessor 1 Does Not Exit"
label var pr`round'cgc "CGC of Predecessor 1"
label var pr`round'num "Number of Predecessors in PIA"
label var pr`round'born "Birth Year of Predecessor 1"
label var pr`round'absrb "Year of Pred. 1's Absorption"
label var pr`round'extyr "Year of Pred. 1's Eff. Exit"
label var pr`round'entrc "Entry Class of Predecessor 1"
label var pr`round'lifec "Exit Class of Predecessor 1"
label var pr`round'lfavg "Avg. Lab. Force of Predecessor 1"
label var pr`round'chg "Change of Predecessor 1's Status"
format pr`round'num pr`round'notex pr`round'notlv %1.0f
format fcorcatl %5.0g
order firm fnotlv fcorcatl pr`round'num pr`round'cgc pr`round'chg pr`round'born pr`round'extyr pr`round'notlv pr`round'notex pr`round'lifec pr`round'entrc pr`round'absrb pr`round'lfavg
save `master', replace


/* Add firms that refer back to predecessors */
/*-------------------------------------------*/
use `main', clear
gen byte smplch=1 if change==10 & cgcsuc~=.
replace smplch=1 if change==3 & cgcsuc~=.
keep if smplch==1
gen byte fnotlv=1 if catlife==float(9.3)
gen float fcorcatl=.
gen byte pr1num=.
rename cgcsuc pr1cgc
rename year pr1absrb
rename effborn feffborn
keep firm fnotlv fcorcatl pr1num pr1cgc pr1absrb firstyr feffborn
label var fnotlv "Referenced Firm Not Alive in PIA"
label var fcorcatl "Corrected Exit Category of Firm"
label var pr1cgc "CGC of Predecessor 1"
label var pr1num "Number of Predecessors 1 in PIA"
label var pr1absrb "Year of Pred. 1's Absorption"
format fnotlv pr1num %1.0f
format fcorcatl %5.0g
order firm fnotl fcorcatl pr1num pr1cgc pr1absrb
sort firm
quietly by firm: keep if _n==1
drop if firm==pr1cgc
sort firm
preserve

sort pr1cgc
keep pr1cgc pr1absrb firm
rename firm firmref
drop if pr1cgc<99
save `augm', replace
use `main', clear
   rename firm pr1cgc
   rename change pr1chg
   rename born pr1born
   rename effextyr pr1extyr
   gen byte pr1notex=1 if catlife==float(9.1) /* Referencing firm does not exit de facto */
   gen byte pr1notlv=1 if catlife==float(9.3) /* Referencing firm never alive in PIA */
   rename catlife pr1lifec
   rename catentry pr1entrc
   egen int pr1lfavg=mean(labftot), by(pr1cgc)
   keep pr1cgc pr1chg pr1born pr1extyr pr1notlv pr1notex pr1lifec pr1entrc pr1lfavg year
   label var pr1cgc "CGC of Predecessor 1"
   label var pr1notlv "Predecessor 1 Not Alive in PIA"
   label var pr1notex "Predecessor 1 Does Not Exit"
   label var pr1lfavg "Avg. Lab. Force of Predecessor 1"
   format pr1notex pr1notlv %1.0f
   sort pr1cgc
   joinby pr1cgc using `augm'
   keep if year<=pr1absrb
   sort pr1cgc firm year
   quietly by pr1cgc firm: keep if _n==_N
   keep pr1cgc pr1chg pr1born pr1extyr pr1notlv pr1notex pr1lifec pr1entrc pr1lfavg firmref
   rename firmref firm
   sort firm
   save `augm', replace
restore

merge firm using `augm'
sort firm pr1cgc
gen byte pr1noshw=1 if _merge==1
drop _merge
/* drop if pr1noshw==1 & pr1absrb>firstyr   /* Alleged absorption after first year in PIA */ */
label var pr1noshw "Alleged Predecessor 1 Not in PIA"
format pr1noshw %1.0f
gen byte pr1spnof=1 if (feffborn>=pr1absrb & feffborn~=.) | pr1chg==4 | pr1chg==6
label var pr1spnof "Spin-Off from Predecessor 1"
format pr1spnof %1.0f
drop feffborn firstyr
replace pr1extyr=pr1extyr+1900
replace pr1absrb=pr1absrb+1900
save `appd', replace

use `master', clear
gen _master=1          /* From master dataset */
append using `appd'
sort       firm fnotlv pr1cgc pr1chg pr1born pr1extyr pr1notlv pr1notex pr1lifec pr1entrc pr1absrb pr1lfavg
quietly by firm fnotlv pr1cgc pr1chg pr1born pr1extyr pr1notlv pr1notex pr1lifec pr1entrc pr1absrb pr1lfavg: keep if _n==1
egen grp=group(firm pr1cgc)
egen mingrp=min(grp), by(firm)
egen maxgrp=max(grp), by(firm)
sort firm
quietly by firm: replace pr1num=maxgrp-mingrp+1
drop mingrp maxgrp grp
sort firm pr1cgc
quietly by firm pr1cgc: gen marker=1 if _n<_N
egen helper=max(marker), by(firm)
egen maxchg=max(pr1chg), by(firm)
egen minchg=min(pr1chg), by(firm)
replace pr1chg=maxchg if pr1chg==.
egen minext=min(pr1absrb), by(firm)
replace pr1extyr=minext if pr1extyr==.
egen maxabsrb=max(pr1absrb), by(firm)
replace pr1absrb=maxabsrb
drop if pr1chg>=8 & helper==1    /* Start eliminating doubles */
drop if fnotlv==1 & helper==1
drop minext maxabsrb
drop if minchg==2 & (maxchg==5 | maxchg==6) & pr1lifec==float(9.3) & helper==1
drop if pr1chg==maxchg & _master==. & helper==1
drop if pr1lifec==float(9.3) & _master==. & helper==1
drop if maxchg==7 & minchg<7 & helper==1
drop minchg maxchg _master marker helper
sort       firm fnotlv pr1cgc pr1chg pr1born pr1extyr pr1notlv pr1notex pr1lifec pr1entrc pr1absrb pr1lfavg
quietly by firm fnotlv pr1cgc pr1chg pr1born pr1extyr pr1notlv pr1notex pr1lifec pr1entrc pr1absrb pr1lfavg: keep if _n==1

egen grp=group(firm pr1cgc)
egen mingrp=min(grp), by(firm)
egen maxgrp=max(grp), by(firm)
sort firm
quietly by firm: replace pr1num=maxgrp-mingrp+1
sort grp
quietly by grp: keep if _n==1
drop mingrp maxgrp grp
sort firm pr1cgc


/* First round of additions to the right */
/*---------------------------------------*/
    local before=`round'
    local round=`round'+1
    preserve
        keep firm pr1num pr1cgc pr1chg pr1born pr1extyr pr1notlv pr1notex pr1entrc pr1lifec pr1absrb pr1lfavg pr1spnof
        rename pr1num pr`round'num        
        rename pr1cgc pr`round'cgc
        rename pr1chg pr`round'chg
        rename pr1born pr`round'born
        rename pr1extyr pr`round'extyr
        rename pr1notlv pr`round'notlv
        rename pr1notex pr`round'notex 
        rename pr1entrc pr`round'entrc
        rename pr1lifec pr`round'lifec
        rename pr1absrb pr`round'absrb
        rename pr1lfavg pr`round'lfavg
        rename pr1spnof pr`round'spnof
        rename firm pr`before'cgc
        sort pr`before'cgc
        save `augm', replace
    restore
    sort pr`before'cgc
    joinby pr`before'cgc  using `augm', unmatched(master)
    drop if _merge==2
    drop _merge
    label var pr`round'notlv "Predecessor `round' Not Alive in PIA"
    label var pr`round'notex "Predecessor `round' Does Not Exit"
    label var pr`round'cgc "CGC of Predecessor `round'"
    label var pr`round'num "Number of Predecessors `round' in PIA"
    label var pr`round'born "Birth Year of Predecessor `round'"
    label var pr`round'absrb "Year of Pred. `round''s Absorption"
    label var pr`round'extyr "Year of Pred. `round''s Eff. Exit"
    label var pr`round'entrc "Entry Class of Predecessor `round'"
    label var pr`round'lifec "Exit Class of Predecessor `round'"
    label var pr`round'lfavg "Avg. Lab. Force of Predecessor `round'"
    label var pr`round'chg "Change of Predecessor `round''s Status"
    label var pr`round'spnof "Spin-Off from Predecessor `round'"
    format pr`round'num %1.0f
    gen byte _delete=1 if pr2chg==10 & pr1absrb<=pr2absrb
    replace _delete=1 if pr1chg==2 & pr2chg==3 & pr1absrb<=pr2absrb
    replace _delete=1 if pr1chg==3 & pr2chg==2 & pr1absrb<=pr2absrb
    replace _delete=1 if pr1chg==3 & pr2chg==3 & pr1absrb<=pr2absrb
    replace _delete=1 if pr1chg==8 & pr2chg==9 & pr1absrb<=pr2absrb
    preserve
       keep pr1cgc pr2cgc pr2absrb _delete
       rename pr1cgc firm
       rename pr2cgc pr1cgc
       rename pr2absrb pr1absrb 
       sort firm pr1cgc
       drop if firm<99
       keep if _delete==1
       save `del', replace
    restore
    sort firm pr1cgc
    joinby firm pr1cgc using `del', unmatched(master)
    drop if _delete==1
    drop if _merge==3
    drop _delete _merge
    sort firm pr1cgc pr2cgc
    quietly by firm pr1cgc pr2cgc: keep if _n==1
    replace fcorcatl=9.15 if firm==pr2cgc & (int(pr1lifec)==1 | int(pr1lifec)==2 | int((pr1lifec-3)*10)==1 | int((pr1lifec-5)*10)==1) & pr2lifec==float(9.1)
    replace fcorcatl=9.35 if firm==pr2cgc & (int(pr1lifec)==1 | int(pr1lifec)==2 | int((pr1lifec-3)*10)==1 | int((pr1lifec-5)*10)==1) & pr2lifec==float(9.3)
    replace pr2notlv=. if firm==pr2cgc
    replace pr2notex=. if firm==pr2cgc
    replace pr2num=. if firm==pr2cgc
    replace pr2born=. if firm==pr2cgc
    replace pr2absrb=. if firm==pr2cgc
    replace pr2extyr=. if firm==pr2cgc
    replace pr2entrc=. if firm==pr2cgc
    replace pr2lifec=. if firm==pr2cgc
    replace pr2cgc=. if firm==pr2cgc

/* Further rounds of additions to the right */
/*------------------------------------------*/
local stop 1
while `stop'~=0 {
    local before=`round'
    local round=`round'+1
    preserve
        keep firm pr1num pr1cgc pr1chg pr1born pr1extyr pr1notlv pr1notex pr1entrc pr1lifec pr1absrb pr1lfavg pr1spnof
        rename pr1num pr`round'num        
        rename pr1cgc pr`round'cgc
        rename pr1chg pr`round'chg
        rename pr1born pr`round'born
        rename pr1extyr pr`round'extyr
        rename pr1notlv pr`round'notlv
        rename pr1notex pr`round'notex 
        rename pr1entrc pr`round'entrc
        rename pr1lifec pr`round'lifec
        rename pr1absrb pr`round'absrb
        rename pr1lfavg pr`round'lfavg
        rename pr1spnof pr`round'spnof
        rename firm pr`before'cgc
        sort pr`before'cgc
        save `augm', replace
    restore
    sort pr`before'cgc
    joinby pr`before'cgc  using `augm', unmatched(master)
    drop if _merge==2
    drop _merge
    /* Drop circular references */
    drop if pr`before'cgc==firm
    local delbef=`before'-1
    while `delbef'>=1 {
        drop if pr`delbef'cgc==pr`round'cgc & pr`delbef'cgc~=.                        /* Circular reference */
        drop if pr`delbef'absrb<pr`round'born & pr`delbef'absrb~=. & pr`round'born~=. /* Non-sensical entry */
        local delbef=`delbef'-1                             
    }
    label var pr`round'notlv "Predecessor `round' Not Alive in PIA"
    label var pr`round'notex "Predecessor `round' Does Not Exit"
    label var pr`round'cgc "CGC of Predecessor `round'"
    label var pr`round'num "Number of Predecessors `round' in PIA"
    label var pr`round'born "Birth Year of Predecessor `round'"
    label var pr`round'absrb "Year of Pred. `round''s Absorption"
    label var pr`round'extyr "Year of Pred. `round''s Eff. Exit"
    label var pr`round'entrc "Entry Class of Predecessor `round'"
    label var pr`round'lifec "Exit Class of Predecessor `round'"
    label var pr`round'lfavg "Avg. Lab. Force of Predecessor `round'"
    label var pr`round'chg "Change of Predecessor `round''s Status"
    label var pr`round'spnof "Spin-Off from Predecessor `round'"
    format pr`round'num %1.0f
    egen crit`round'=sum(pr`round'num)
    local stop=crit`round'[_N]
}
drop crit`before'-crit`round'
local i 3
while `i'<`before' {
    drop crit`i'
    local i=`i'+1
}
if `round'==3 {
    local `varlst'=
}
local remrnd=`round'
local gennumb=`remrnd'-1

sort firm pr1cgc-pr`before'cgc
merge firm using `fborn'
gen byte fnoshw=1 if _merge==1
drop if _merge==2
drop _merge
label var fnoshw "Referenced Firm Not in PIA"
label var fborn "Birth Year of Referenced Firm"
label var flfavg "Average Labor Force of Firm"
label var fcatentr "Entry Class of Firm"
format fnoshw %1.0f
order firm fborn fnotlv fnoshw fcorcatl fcatentr flfavg
sort firm-pr`before'absrb


/* Determine economic age of firm */
/*--------------------------------*/
gen int  feconbrn=pr1born  if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10
replace  feconbrn=0        if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10 & pr1born==.
gen long dpredcgc=pr1cgc   if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10
gen byte dprchg=pr1chg     if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10
gen int  dprborn=pr1born   if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10
gen int  dprextyr=pr1extyr if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10
gen byte dprnotex=pr1notex if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10
gen long dprlfavg=pr1lfavg if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10
gen byte dprnum=pr1num     if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10
gen int  dprabsrb=pr1absrb if fborn>=pr1absrb & pr1born<fborn & pr1notlv~=1 & pr1chg~=10
replace feconbrn=pr1born   if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10
replace feconbrn=0         if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10  & pr1born==.
replace dpredcgc=pr1cgc    if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10
replace dprchg=pr1chg      if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10
replace dprborn=pr1born    if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10
replace dprextyr=pr1extyr  if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10
replace dprnotex=pr1notex  if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10
replace dprlfavg=pr1lfavg  if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10
replace dprnum=pr1num      if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10
replace dprabsrb=pr1absrb  if pr1born<fborn & (pr1lfavg>=.6667*flfavg) & fnoshw~=1 & pr1chg~=10
local i 2
while `i'<=`before' {
    replace dpredcgc=pr`i'cgc   if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 & (pr`i'born<feconbrn | feconbrn==0 | feconbrn==.) & pr`i'chg~=10 & pr1chg~=10
    replace dprchg=pr`i'chg     if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 & (pr`i'born<feconbrn | feconbrn==0 | feconbrn==.) & pr`i'chg~=10 & pr1chg~=10
    replace dprborn=pr`i'born   if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 & (pr`i'born<feconbrn | feconbrn==0 | feconbrn==.) & pr`i'chg~=10 & pr1chg~=10
    replace dprextyr=pr`i'extyr if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 & (pr`i'born<feconbrn | feconbrn==0 | feconbrn==.) & pr`i'chg~=10 & pr1chg~=10
    replace dprnotex=pr`i'notex if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 & (pr`i'born<feconbrn | feconbrn==0 | feconbrn==.) & pr`i'chg~=10 & pr1chg~=10
    replace dprlfavg=pr`i'lfavg if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 & (pr`i'born<feconbrn | feconbrn==0 | feconbrn==.) & pr`i'chg~=10 & pr1chg~=10
    replace dprnum=pr1num       if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 & (pr`i'born<feconbrn | feconbrn==0 | feconbrn==.) & pr`i'chg~=10 & pr1chg~=10
    replace dprabsrb=pr1absrb   if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 & (pr`i'born<feconbrn | feconbrn==0 | feconbrn==.) & pr`i'chg~=10 & pr1chg~=10
    replace feconbrn=pr`i'born  if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 & (pr`i'born<feconbrn | feconbrn==0 | feconbrn==.) & pr`i'chg~=10 & pr1chg~=10
    /* replace feconbrn=0       if pr`i'born<fborn & (pr`i'lfavg>=.6667*flfavg) & fnoshw~=1 &                                                    pr`i'chg~=10 & pr1chg~=10 & pr`i'born==. */
    /* replace feconbrn=1       if pr`i'born<fborn & (pr`i'lfavg <.6667*flfavg) & fnoshw~=1 & feconbrn==. & pr`i'chg~=10 & pr1chg~=10 */
    local i=`i'+1
}
egen helper=min(feconbrn), by(firm)
replace feconbrn=helper
sort firm
quietly by firm: gen marker=dpredcgc if feconbrn==helper & dpredcgc~=.
egen spiller=min(dpredcgc), by(firm)
replace dpredcgc=spiller
drop helper marker spiller
format dprchg dprnotex dprnum %1.0f
format feconbrn dprborn dprextyr dprabsrb %4.0f
format dpredcgc %8.0f  /* Decisive predecessor for age */
label var feconbrn "Economic Age by Succession"
label var dpredcgc "Decisive Predecessor for Age"
label var dprchg   "Change of Dec. Pred.'s Status"
label var dprborn  "Birth Year of Dec. Predecessor"
label var dprextyr "Year of Dec. Pred.'s Eff. Exit"
label var dprnotex "Dec. Predecessor Does Not Exit"
label var dprlfavg "Avg. Lab. Force of Dec. Predec."
label var dprnum   "Number of Immed. Pred.s in PIA"
label var dprabsrb "Dec. Pred.'s (Indir.) Absorption"

gen fcorcate=2.1 if fcatentr==float(2)
replace fcorcate=2.2 if fborn>=pr1absrb & fborn~=. & fcatentr==float(2)
replace fcorcate=2.3 if fborn>=pr1absrb & fborn~=. & fcatentr==float(2) & pr1chg==1
replace fcorcate=2.4 if fborn>=pr1absrb & fborn~=. & fcatentr==float(2) & (pr1chg==4 | pr1chg==5)
replace fcorcate=2.5 if fborn>=pr1absrb & fborn~=. & fcatentr==float(2) & (pr1chg==6)
replace fcorcate=8.1 if fcatentr==float(8)
replace fcorcate=8.2 if fborn>=pr1absrb & fborn~=. & fcatentr==float(8)
replace fcorcate=8.3 if fborn>=pr1absrb & fborn~=. & fcatentr==float(8) & pr1chg==1
replace fcorcate=8.4 if fborn>=pr1absrb & fborn~=. & fcatentr==float(8) & (pr1chg==4 | pr1chg==5)
replace fcorcate=8.5 if fborn>=pr1absrb & fborn~=. & fcatentr==float(8) & (pr1chg==6)
replace fcorcate=4.11 if fcatentr==float(4.1)
replace fcorcate=4.12 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.1)
replace fcorcate=4.13 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.1) & pr1chg==1
replace fcorcate=4.14 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.1) & (pr1chg==4 | pr1chg==5)
replace fcorcate=4.15 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.1) & (pr1chg==6)
replace fcorcate=4.21 if fcatentr==float(4.2)
replace fcorcate=4.22 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.2)
replace fcorcate=4.23 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.2) & pr1chg==1
replace fcorcate=4.24 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.2) & (pr1chg==4 | pr1chg==5)
replace fcorcate=4.25 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.2) & (pr1chg==6)
replace fcorcate=4.31 if fcatentr==float(4.3)
replace fcorcate=4.32 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.3)
replace fcorcate=4.33 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.3) & pr1chg==1
replace fcorcate=4.34 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.3) & (pr1chg==4 | pr1chg==5)
replace fcorcate=4.35 if fborn>=pr1absrb & fborn~=. & fcatentr==float(4.3) & (pr1chg==6)

order firm feconbrn fborn fnotlv fnoshw fcorcatl fcorcate fcatentr flfavg
format fcorcate %4.0g
label var fcorcate "Corrected Entry Category of Firm"
sort firm pr1cgc pr2cgc pr3cgc pr`before'cgc
save "brazprod\cgc-lig\refer", replace
/* Note: The algorithm automatically produces the precise number of generations, currently three */
/*       Otherwise an error will occur at line "quietly by firm feconbrn fcorcatl ..." due to remaining generation */
/*       See next command line */

/* Update Information in main dataset */
/*------------------------------------*/
drop pr1num-pr3spnof  /* If error encountered below: AUGMENT number of generations HERE */
drop if fnoshw==1
drop fborn fnotlv fnoshw fcatentr
sort firm-dprabsrb
quietly by firm feconbrn fcorcatl fcorcate flfavg dpredcgc dprchg dprborn dprextyr dprnotex dprlfavg dprnum dprabsrb: keep if _n==1
/* If error message encountered here, go to first line of this section and drop all generations */
sort firm dpredcgc
quietly by firm: keep if _n==1
save `refer', replace
use `main', clear
replace catentry=2.1 if catentry==2
replace catentry=8.1 if catentry==8
merge firm using `refer'
drop _merge
sort firm year
replace catentry=4.11 if catentry==float(4.1)
replace catentry=4.21 if catentry==float(4.2)
replace catentry=4.31 if catentry==float(4.3)
replace catentry=4.41 if catentry==float(4.4)
replace catentry=fcorcate if fcorcate~=.
replace catlife=fcorcatl if fcorcatl~=.
format catentry %5.0g
drop fcorcatl fcorcate
rename feconbrn econborn
rename flfavg labfavg
preserve
  keep  firm born effborn firstyr lastyr catentry catlife effextyr fstsusyr contgrp labfavg indsctch indnoind miss86-miss98 econborn dpredcgc dprchg dprborn dprextyr dprnotex dprlfavg dprabsrb dprnum
  order firm born effborn econborn firstyr lastyr catentry catlife fstsusyr effextyr contgrp labfavg indsctch indnoind miss86-miss98 dpredcgc dprchg dprborn dprextyr dprnotex dprlfavg dprabsrb dprnum
  sort firm
  quietly by firm: keep if _n==1
  save `firmhd', replace
        insheet using "brazprod\cgc-lig\recat.csv", clear
        drop v3 v4 v5 v8 v9
        keep catentry catentsi
        label var catentsi "Simplified Entry Classification"
        drop if catentry==.
        sort catentry
        save `entry', replace
        insheet using "brazprod\cgc-lig\recat.csv", clear
        drop v3 v4 v5 v8 v9
        keep catlife catlifsi
        label var catlifsi "Simplified Exit Classification"
        drop if catlife==.
        sort catlife
        save `exit', replace
  use `firmhd', clear
  sort catentry
  merge catentry using `entry', nokeep
  drop _merge
  sort catlife
  merge catlife using `exit', nokeep
  drop _merge
  order firm born effborn econborn firstyr lastyr catentry catentsi catlife catlifsi fstsusyr effextyr contgrp labfavg indsctch indnoind miss86-miss98 dpredcgc dprchg dprborn dprextyr dprnotex dprlfavg dprabsrb dprnum
  sort firm
  save "brazprod\cgc-lig\firmhead", replace
restore

replace cgcsuc=. if dpredcgc==cgcsuc & dpredcgc~=.
rename dprnum prednum
order firm year state change cgcsuc born effborn econborn firstyr lastyr catentry catlife fstsusyr effextyr dpredcgc dprchg dprborn dprextyr dprnotex dprlfavg dprabsrb prednum indsctch indnoind chmon chyr sales difstock resales astot asliq aslr aspsum aspinv aspimmo aspmasum aspdefer asrtimmo aslsimmo deprec fincost balsum crtot crstsum crstdom crstfor crltsum crltdom crltfor labftot labftop labfwh labfbl wagetot wagetop wagewh wagebl acqtot acqbl acqmasum acqmadom acqmause acqmafor acqveh acqother acqcomp asltot aslbl aslmasum aslveh aslother aslcomp intmacq intmdif profit niv100 niv80map region uf genero class weight cgcemp labfavg contgrp indcor indnolnk existsuc
sort  firm year
save "brazprod\data\pia-finl.dta", replace

/* disp "There were `remrnd' rounds of additions to the right." */
disp "A maximum number of `gennumb' generations was identified."
