version 6.0
tempfile cgc8690 cgc9295 cgc9698 cgcl86 cgcl87 cgcl88 cgcl89 cgcl90 cgcl92 cgcl93 cgcl94 cgcl95 cgcl96 cgcl97 cgcl98
tempfile lig96 lig97 lig98 born
tempfile cgccr86 cgccr87 cgccr88 cgccr89 cgccr90

/* CGC connections between 86 and 90 */
capture program drop yrprep0
program define yrprep0
  args yr tmpfile
  insheet using "brazprod\cgc-lig\cgccor`yr'.csv", clear
  rename empresa firm
  rename cgccor cgccorr
  gen byte cgcemp=cgcnovo/10000
  format cgcemp %12.0g
  drop cgcnovo
  gen byte year=`yr'
  order firm year cgcemp cgccorr
  label var firm "Tax Number (CGC)"
  label var year "Calendar Year"
  label var cgcemp "(cgcemp) Connecting CGC"
  label var cgccorr "(indcor) Indicator Corrected CGC"
  sort firm year
  save `tmpfile', replace 
end
capture program drop yrprep1
program define yrprep1
  args yr tmpfile
  insheet using "brazprod\cgc-lig\cgclig`yr'.csv", clear
  drop ul qst ulant ulemp
  rename sitcod sitcad
  rename empresa firm
  rename ano year
  replace year=year-1900
  rename cgcant cgcantsc
  gen byte cgccorr=.
  order firm year sitcad sitmes sitano modif cgcantsc cgcemp cgccorr
  label var firm "Tax Number (CGC)"
  label var year "Calendar Year"
  label var sitcad "(state) State of Activity"  
  label var sitmes "(chmon) Month of Change"
  label var sitano "(chyr) Year of Change"
  label var modif "(change) Structural Change"
  label var cgcantsc "(cgcsuc) Previous/Following CGC"
  label var cgcemp "(cgcemp) Connecting CGC"
  label var cgccorr "(indcor) Indicator Corrected CGC"
  format firm cgcantsc cgcemp %8.0f
  format year sitmes sitano modif %2.0f
  format sitcad cgccorr %1.0f
  sort firm year
  save `tmpfile', replace
end
yrprep0 86 `cgccr86'
yrprep0 87 `cgccr87'
yrprep0 88 `cgccr88'
yrprep0 89 `cgccr89'
yrprep0 90 `cgccr90'
use `cgccr86', clear
append using `cgccr87'
append using `cgccr88'
append using `cgccr89'
append using `cgccr90'
sort firm year
preserve
yrprep1 86 `cgcl86'
yrprep1 87 `cgcl87'
yrprep1 88 `cgcl88'
yrprep1 89 `cgcl89'
yrprep1 90 `cgcl90'
use `cgcl86', clear
append using `cgcl87'
append using `cgcl88'
append using `cgcl89'
append using `cgcl90'
sort firm year
save `cgc8690', replace
restore
merge firm year using `cgc8690'
drop if firm==.
drop _merge
order firm year sitcad sitmes sitano modif cgcantsc cgcemp cgccorr
save `cgc8690', replace

/* CGC connections between 92 and 95 */
capture program drop yrprep2
program define yrprep2
  args yr tmpfile
  insheet using "brazprod\cgc-lig\cgclig`yr'.csv", clear
  drop carimbo motivemp
  rename empresa firm
  rename ano year
  rename modifano modif
  rename situa sitcad
  gen byte sitmes=int(dataocor/100)
  gen byte sitano=dataocor-sitmes*100
        gen str7 _dummy1=string(int(cgcempr/10000000))
        replace _dummy1= "0" + _dummy1 if length(_dummy1)==6
        replace _dummy1= "00" + _dummy1 if length(_dummy1)==5
        replace _dummy1= "000" + _dummy1 if length(_dummy1)==4
        replace _dummy1= "0000" + _dummy1 if length(_dummy1)==3
        replace _dummy1= "00000" + _dummy1 if length(_dummy1)==2
        replace _dummy1= "000000" + _dummy1 if length(_dummy1)==1
        replace _dummy1="." if substr(_dummy1,-1,1)=="."
        gen str7 _dummy2=string(cgcempr-int(cgcempr/10000000)*10000000)
        replace _dummy2= "0" + _dummy2 if length(_dummy2)==6
        replace _dummy2= "00" + _dummy2 if length(_dummy2)==5
        replace _dummy2= "000" + _dummy2 if length(_dummy2)==4
        replace _dummy2= "0000" + _dummy2 if length(_dummy2)==3
        replace _dummy2= "00000" + _dummy2 if length(_dummy2)==2
        replace _dummy2= "000000" + _dummy2 if length(_dummy2)==1
        replace _dummy2="." if substr(_dummy2,-1,1)=="."
        gen str14 _dummy3=_dummy1 + _dummy2
        replace _dummy3="." if substr(_dummy3,-1,1)=="."
        rename _dummy3 cgcempst
        drop _dummy1 _dummy2
        replace cgcempst="." if cgcempr==0
        gen str7 _dummy1=string(int(cgcnovo/10000000))
        replace _dummy1= "0" + _dummy1 if length(_dummy1)==6
        replace _dummy1= "00" + _dummy1 if length(_dummy1)==5
        replace _dummy1= "000" + _dummy1 if length(_dummy1)==4
        replace _dummy1= "0000" + _dummy1 if length(_dummy1)==3
        replace _dummy1= "00000" + _dummy1 if length(_dummy1)==2
        replace _dummy1= "000000" + _dummy1 if length(_dummy1)==1
        replace _dummy1="." if substr(_dummy1,-1,1)=="."
        gen str7 _dummy2=string(cgcnovo-int(cgcnovo/10000000)*10000000)
        replace _dummy2= "0" + _dummy2 if length(_dummy2)==6
        replace _dummy2= "00" + _dummy2 if length(_dummy2)==5
        replace _dummy2= "000" + _dummy2 if length(_dummy2)==4
        replace _dummy2= "0000" + _dummy2 if length(_dummy2)==3
        replace _dummy2= "00000" + _dummy2 if length(_dummy2)==2
        replace _dummy2= "000000" + _dummy2 if length(_dummy2)==1
        replace _dummy2="." if substr(_dummy2,-1,1)=="."
        gen str14 _dummy3=_dummy1 + _dummy2
        replace _dummy3="." if substr(_dummy3,-1,1)=="."
        rename _dummy3 cgcnovst
        drop _dummy1 _dummy2
        replace cgcnovst="." if cgcnovo==0
        gen byte _marker=1 if substr(cgcempst,1,6)=="000000"
        replace _marker=1  if substr(cgcnovst,1,6)=="000000"
        replace cgcempst=substr(cgcempst,7,14)+"......" if substr(cgcempst,1,6)=="000000"
        replace cgcnovst=substr(cgcnovst,7,14)+"......" if substr(cgcnovst,1,6)=="000000"
        replace _marker=2 if substr(cgcempst,1,2)=="00" & _marker==. & substr(cgcempst,-4,2)=="00"
        replace _marker=2 if substr(cgcnovst,1,2)=="00" & _marker==. & substr(cgcnovst,-4,2)=="00"
        replace cgcempst=substr(cgcempst,3,12)+".." if (substr(cgcempst,1,2)=="00" & substr(cgcempst,-4,2)=="00")
        replace cgcnovst=substr(cgcnovst,3,12)+".." if (substr(cgcnovst,1,2)=="00" & substr(cgcnovst,-4,2)=="00")
        replace _marker=3 if substr(cgcempst,1,1)=="0" & _marker==. & substr(cgcempst,-5,3)=="000"
        replace _marker=3 if substr(cgcnovst,1,1)=="0" & _marker==. & substr(cgcnovst,-5,3)=="000"
        replace cgcempst=substr(cgcempst,2,13)+"." if (substr(cgcempst,1,1)=="0" & _marker~=1 & substr(cgcempst,-5,3)=="000")
        replace cgcnovst=substr(cgcnovst,2,13)+"." if (substr(cgcnovst,1,1)=="0" & _marker~=1 & substr(cgcnovst,-5,3)=="000")
        replace cgcempr=real(substr(cgcempst,1,8))
        replace cgcnovo=real(substr(cgcnovst,1,8))
        drop _marker cgcempst cgcnovst
  rename cgcempr cgcantsc
  rename cgcnovo cgcemp
  drop dataocor
  order firm year sitcad sitmes sitano modif cgcantsc cgcemp cgccorr
  label var firm "Tax Number (CGC)"
  label var year "Calendar Year"
  label var sitcad "(state) State of Activity"  
  label var sitmes "(chmon) Month of Change"
  label var sitano "(chyr) Year of Change"
  label var modif "(change) Structural Change"
  label var cgcantsc "(cgcsuc) Previous/Following CGC"
  label var cgcemp "(cgcemp) Connecting CGC"
  label var cgccorr "(indcor) Indicator Corrected CGC"
  format firm cgcantsc cgcemp %8.0f
  format year sitmes sitano modif %2.0f
  format sitcad cgccorr %1.0f
  sort firm year
  save `tmpfile', replace
end
yrprep2 92 `cgcl92'
yrprep2 93 `cgcl93'
yrprep2 94 `cgcl94'
yrprep2 95 `cgcl95'
use `cgcl92', clear
append using `cgcl93'
append using `cgcl94'
append using `cgcl95'
save `cgc9295', replace

/* CGC connections between 96 and 98 */
local yr 96  /* Only 96, 97, 98 */
use "brazprod\cgc-list\cgc-nasc.dta", clear
rename firm cgcantsc
rename born cgcborn
label var cgcborn "Founding Year of Referenced Firm"
sort cgcantsc
save `born', replace
while `yr'<=98 {
insheet using "brazprod\pia-e\pianova`yr'.csv", clear
gen ano=`yr'
keep empresa modelo sitcad mesocor anoocor mudestr raizlig*
sort empresa modelo sitcad mesocor anoocor mudestr raizlig1 raizlig2 raizlig3
quietly by empresa modelo sitcad mesocor anoocor mudestr raizlig1 raizlig2 raizlig3: keep if _n==1
rename modelo model
format model %1s
label var model "Type of Questionnaire"
rename empresa firm
gen int year=`yr'
gen byte sitmes=int(real(mesocor))
gen byte sitano=int(real(anoocor))-1900
drop mesocor anoocor
gen mudanca=int(real(mudestr))
drop mudestr
reshape long raizlig, i(firm) j(lignum)
gen cgcantsc=int(real(raizlig))
drop raizlig
gen modif=.
order firm year lignum model sitcad sitmes sitano mudanca modif cgcantsc
sort firm model sitcad sitmes sitano mudanca cgcantsc
quietly by firm model sitcad sitmes sitano mudanca cgcantsc: keep if _n==1
quietly by firm: gen _marker=1 if _n==1
drop if cgcantsc==. & _marker~=1
drop _marker lignum
quietly by firm: gen _dummy=1 if _n>1
egen byte multlig=max(_dummy), by(firm)
drop _dummy
/* Translation of sitcad to 86-95 standard */
gen byte indext`yr'=1 if sitcad==7
replace sitcad=6 if sitcad==7
replace sitcad=7 if sitcad==8
replace sitcad=8 if sitcad>=9 & sitcad~=.
/* Translation of mudanca to modif standard 86-95 */
sort cgcantsc
merge cgcantsc using `born', nokeep
drop _merge
sort cgcantsc
quietly by cgcantsc: gen _pmrg=1 if _n>1
egen _crit1=max(_pmrg), by(cgcantsc)  /* _crit1: Referenced Firm is being referenced more than once */
drop _pmrg
replace modif=4 if mudanca==1                           /* Default translation: 1 to 4 */
replace modif=1 if mudanca==1 & multlig==. & _crit1==1  /* Merger: 1 to 1 */
drop _crit1
replace modif=2 if mudanca==3 & sitcad>=4
replace modif=3 if mudanca==3 & sitcad<=3
replace modif=7 if mudanca==. & sitcad>=4 & cgcantsc==.
replace modif=10 if mudanca==6
replace modif=5 if mudanca==2 & cgcborn-1900<`yr'
replace modif=6 if mudanca==2 & cgcborn-1900>=`yr'
replace modif=8 if mudanca==4
replace modif=9 if mudanca==5
replace mudanca=. if mudanca==0
drop cgcborn mudanca
format firm cgcantsc %8.0f
format year sitmes sitano modif %2.0f
format sitcad indext`yr' multlig %1.0f
label var firm "Tax Number (CGC)"
label var year "Calendar Year"
label var sitcad "(state) State of Activity"
label var sitmes "(chmon) Month of Change"
label var sitano "(chyr) Year of Change"
label var modif "(change) Structural Change"
label var cgcantsc "Previous/Following CGC"
label var multlig "Multiple Connecting Firms"
label var indext`yr' "Extinct before `yr'"
sort firm
save `lig`yr'', replace
local yr=`yr'+1
}
use `lig96', clear
append using `lig97'
append using `lig98'
save `cgc9698', replace

use `cgc8690', clear
replace sitmes=. if sitmes>12 & sitmes~=. /* Error correction in 86 */
append using `cgc9295'
replace cgcemp=. if cgcemp==0
replace cgcemp=firm if cgcemp==int(firm/10) | cgcemp==int(firm/100) | cgcemp==int(firm/1000) | cgcemp==int(firm/10000)
append using `cgc9698'
replace sitano=. if (sitano<10 | sitano>98) & sitano~=.

/* Some error corrections */
replace sitmes=. if sitmes>12
replace modif=. if modif>10
replace sitcad=. if sitcad>8

order firm year sitcad sitmes sitano modif cgcantsc cgcemp cgccorr multlig indext* model
sort firm year
save "brazprod\cgc-lig\cgc-lig", replace
