version 7.0
tempfile tarifa tarifrx master tmp tmp0 gendefl reuse reuse1 reuse2 niv80 penet ramimp
tempfile inout86 inout87 inout88 inout89 inout90 inout91 inout92 inout93 inout94 inout95 inout96 inout97 inout98
tempfile intrf86 intrf87 intrf88 intrf89 intrf90 intrf91 intrf92 intrf93 intrf94 intrf95 intrf96 intrf97 intrf98 intrf99
tempfile capf86 capf87 capf88 capf89 capf90 capf91 capf92 capf93 capf94 capf95 capf96 capf97 capf98
tempfile cap1 cap2 cap3 cap4 cap5

local type "ipa-og"  /* Used for Real Exchange Rate */
/* Type of R$ Deflator: "igp-di", "inpc", "inpc-real", 
                        "ipa-indtot", "ipa-og", "ipa-transf"
                        see "brazprod\deflate\general-defl.dta" */

local usdtype "usd-prodpi"  /* Used for Real Exchange Rate */
/* Type of US$ Deflator: "usd-cpiai", "usd-prodpi", "usd-intlpi"
                         see "brazprod\deflate\general-defl.dta" */


/* Rebase Deflators to Aug 1994 */
/*------------------------------*/
capture program drop rebase
program define rebase
    args yr maxyr
    while `yr'<=`maxyr' {
    quietly replace jan`yr'=(jan`yr'/aug94)
    quietly replace feb`yr'=(feb`yr'/aug94)
    quietly replace mar`yr'=(mar`yr'/aug94)
    quietly replace apr`yr'=(apr`yr'/aug94)
    quietly replace may`yr'=(may`yr'/aug94)
    quietly replace jun`yr'=(jun`yr'/aug94)
    quietly replace jul`yr'=(jul`yr'/aug94)
    if `yr'~=94 {quietly replace aug`yr'=(aug`yr'/aug94)}
    quietly replace sep`yr'=(sep`yr'/aug94)
    quietly replace oct`yr'=(oct`yr'/aug94)
    quietly replace nov`yr'=(nov`yr'/aug94)
    quietly replace dec`yr'=(dec`yr'/aug94)
    local yr=`yr'+1
    }
    quietly replace aug94=1
end

/* Prepare Real Exchange Rate */
/*----------------------------*/
use "brazprod\deflate\general-defl", clear
rebase 86 99
save `gendefl', replace
insheet using "brazprod\deflate\fgv\dollar.csv", clear
drop jan85-dec85
rename v1 usdtype
format usdtype %-10s
keep if usdtype=="dolarmedio"
rename usdtype defltype
gen byte _marker=1
sort _marker
append using `gendefl'
keep if defltype=="dolarmedio" | defltype=="`type'" | defltype=="`usdtype'"
drop inddefl
set matsize 168
mkmat jan86-dec99, matrix(SER)
matrix SER=SER'
matrix colnames SER = dolarmed deflator usddefl
drop _all
svmat double SER
rename SER1 dolarmed
rename SER2 deflator
rename SER3 usddefl
gen double realexch=(dolarmed*usddefl)/deflator
gen double realx100=realexch*100
mkmat dolarmed deflator usddefl realexch realx100, matrix(SER)
matrix SER=SER'
drop _all
svmat double SER
local i 1
while `i'<=168 {
  local yr=85+int(`i'/12+(1-1/12))
  if (`i'+11)/12==int((`i'+11)/12) {rename SER`i' jan`yr'}
  capture label var jan`yr' "Jan-`yr'"
  if (`i'+10)/12==int((`i'+10)/12) {rename SER`i' feb`yr'}
  capture label var feb`yr' "Feb-`yr'"
  if (`i'+9)/12==int((`i'+9)/12)   {rename SER`i' mar`yr'}
  capture label var mar`yr' "Mar-`yr'"
  if (`i'+8)/12==int((`i'+8)/12)   {rename SER`i' apr`yr'}
  capture label var apr`yr' "Apr-`yr'"
  if (`i'+7)/12==int((`i'+7)/12)   {rename SER`i' may`yr'}
  capture label var may`yr' "May-`yr'"
  if (`i'+6)/12==int((`i'+6)/12)   {rename SER`i' jun`yr'}
  capture label var jun`yr' "Jun-`yr'"
  if (`i'+5)/12==int((`i'+5)/12)   {rename SER`i' jul`yr'}
  capture label var jul`yr' "Jul-`yr'"
  if (`i'+4)/12==int((`i'+4)/12)   {rename SER`i' aug`yr'}
  capture label var aug`yr' "Aug-`yr'"
  if (`i'+3)/12==int((`i'+3)/12)   {rename SER`i' sep`yr'}
  capture label var sep`yr' "Sep-`yr'"
  if (`i'+2)/12==int((`i'+2)/12)   {rename SER`i' oct`yr'}
  capture label var oct`yr' "Oct-`yr'"
  if (`i'+1)/12==int((`i'+1)/12)   {rename SER`i' nov`yr'}
  capture label var nov`yr' "Nov-`yr'"
  if (`i')/12==int((`i')/12)       {rename SER`i' dec`yr'}
  capture label var dec`yr' "Dec-`yr'"
  local i=`i'+1
}
gen str10 defltype="dolarmedio"
replace defltype="`type'" in 2
replace defltype="`usdtype'" in 3
replace defltype="realexch" in 4
replace defltype="realex100" in 5
format defltype %-10s
order defltype
/* Leave unsorted. 1st line: nominal exchange rate; 2nd: domestic deflator, 3rd: foreign deflator; 4th: real exch rate, 5th: real exch rate*1 */
compress
save "brazprod\deflate\realexch", replace

/* Prepare temp file for later use with tariffs */
drop if defltype~="realexch"
rebase 86 99
local yr 86
while `yr'<=99 {
    rename jan`yr' mjan`yr'
    rename feb`yr' mfeb`yr'
    rename mar`yr' mmar`yr'
    rename apr`yr' mapr`yr'
    rename may`yr' mmay`yr'
    rename jun`yr' mjun`yr'
    rename jul`yr' mjul`yr'
    rename aug`yr' maug`yr'
    rename sep`yr' msep`yr'
    rename oct`yr' moct`yr'
    rename nov`yr' mnov`yr'
    rename dec`yr' mdec`yr'
    local yr=`yr'+1
}
reshape long mjan mfeb mmar mapr mmay mjun mjul maug msep moct mnov mdec, i(defltype) j(year)
rename mjan realx1
rename mfeb realx2
rename mmar realx3
rename mapr realx4
rename mmay realx5
rename mjun realx6
rename mjul realx7
rename maug realx8
rename msep realx9
rename moct realx10
rename mnov realx11
rename mdec realx12
reshape long realx, i(defltype year) j(month)
drop defltype year month
save `reuse', replace


/* Penetration Indices */
/*---------------------*/
/* Mesquita Indices */
use "brazprod\deflate\comp-defl", clear
keep niv80map indtype
sort niv80map
quietly by niv80map: keep if _n==1
save `tmp0', replace
use "brazprod\filters\niv10080", clear
keep nivmap niv80
rename nivmap niv80map
sort niv80 
quietly by niv80: keep if _n==1
sort niv80map
merge niv80map using `tmp0'
drop niv80map _merge
label var niv80 "NIVEL 80"
sort indtype niv80
preserve
    insheet using "brazprod\addl\mesq-penet.csv", clear
    gen byte year=(valorese-1900)
    format year %2.0f
    gen pent1=impbcd/consbcd
    gen pent2=impbc/consbc
    gen pent3=impbine/consbine
    gen pent4=impbi/consbi
    gen pent5=impbk/consbk
    gen pent6=impbket/consbket
    rename prodbcd  prod1
    rename prodbc   prod2
    rename prodbine prod3
    rename prodbi   prod4
    rename prodbk   prod5
    rename prodbket prod6
    rename impbcd  imp1
    rename impbc   imp2
    rename impbine imp3
    rename impbi   imp4
    rename impbk   imp5
    rename impbket imp6
    rename expbcd  exp1
    rename expbc   exp2
    rename expbine exp3
    rename expbi   exp4
    rename expbk   exp5
    rename expbket exp6
    keep year pent1 pent2 pent3 pent4 pent5 pent6 prod1 prod2 prod3 prod4 prod5 prod6 imp1 imp2 imp3 imp4 imp5 imp6 exp1 exp2 exp3 exp4 exp5 exp6
    reshape long pent prod imp exp, i(year) j(indnum)
    gen str4 indtype="bcd" if indnum==1
    replace  indtype="bc" if indnum==2
    replace  indtype="bine" if indnum==3
    replace  indtype="bi" if indnum==4
    replace  indtype="bk" if indnum==5
    replace  indtype="bket" if indnum==6
    format indtype %-4s
    drop indnum
    rename pent meffpen
    rename prod mprod
    rename imp mimp
    rename exp mexp
    order indtype year meffpen mprod mimp mexp
    sort indtype year
    label var indtype "Type of Industry"
    label var meffpen "Mesq: Eff. Penetr. of Industry"
    label var mprod   "Mesq: Ind. Level Prod. (US$)"
    label var mimp    "Mesq: Ind. Level Imports (US$)"
    label var mexp    "Mesq: Ind. Level Exports (US$)"
    label var year    "Calendar Year"
    sort indtype year
    save `penet', replace
restore
joinby indtype using `penet'
sort niv80 year
save `penet', replace

/* Ramos Indices */
insheet using "brazprod\addl\ramos-penet-imp.csv", clear
rename nivel80 niv80
label var niv80 "Nivel 80 Sector of Industry"
rename descrica desc80
format desc80 %-50s
label var desc80 "Nivel 80 Descricao dos Setores"
rename descript desc80en
format desc80en %-56s
label var desc80en "Nivel 80 Sector Description"
drop v4
rename v5 imppen85
label var imppen85 "Penetration in 1985"
local i 0
while `i'<=8 {
    local i1=`i'+6
    local i2=`i'+90
    local i3=`i'+1990
    rename v`i1' imppen`i2'
    label var imppen`i2' "Penetration in `i3'"
    local i=`i'+1
}
sort niv80
preserve
    drop imppen*
    save `tmp0', replace
    use "brazprod\filters\niv10080", clear
    sort niv100
    merge niv100 using "brazprod\deflate\comp-defl"
    keep if _merge==3
    rename descript desc100
    label var desc100 "Nivel 100 Sector Description"
    label var niv80 "Nivel 80 Sector of Industry"
    label var niv100 "Nivel 100 Sector of Industry"
    label var ativ80 "Activity (Nivel 80 Atividade)"
    label var niv80map "Nivel 80 Compatible Sector"
    label var ipadi "DI-FGV Index Industry"
    label var descdi "DI-FGV Sector Description"
    label var coluna "IPA-FGV Index Industry"
    label var descipa "IPA-FGV Sector Description"
    drop _merge nivmap
    sort niv80 niv100
    quietly by niv80 niv100: keep if _n==1
    merge niv80 using `tmp0'
    drop _merge mesq
    drop if ativ80==.
    rename desc80 desc80p
    replace desc80p="" if desc80p=="X"
    rename desc80en desc80
    replace desc80="" if desc80=="X"
    sort niv80 niv100
    order niv80 desc80 desc80p ativ80 niv100 desc100 niv80map
    compress
    save "brazprod\filters\sectors", replace
restore
drop desc*
local step 1
while `step'<=4 { 
    local yr=`step'+85
    local flyr=`yr'+1900
    gen imppen`yr'=imppen85+`step'*((imppen90-imppen85)/5)
    label var imppen`yr' "Penetration in `flyr'"
    local step=`step'+1
}
drop imppen85
order niv80 imppen86-imppen89 imppen90-imppen98
local yr 86
while `yr'<=98 {
    replace imppen`yr'=imppen`yr'/100
    local yr=`yr'+1
}
sort niv80
save `ramimp', replace

insheet using "brazprod\addl\ramos-penet-exp.csv", clear
rename nivel80 niv80
label var niv80 "Nivel 80 Sector of Industry"
drop desc*
drop v4
rename v5 expsh85
label var expsh85 "Export Share in 1985"
local i 0
while `i'<=8 {
    local i1=`i'+6
    local i2=`i'+90
    local i3=`i'+1990
    rename v`i1' expsh`i2'
    label var expsh`i2' "Export Share in `i3'"
    local i=`i'+1
}
sort niv80
local step 1
while `step'<=4 { 
    local yr=`step'+85
    local flyr=`yr'+1900
    gen expsh`yr'=expsh85+`step'*((expsh90-expsh85)/5)
    label var expsh`yr' "Export Share in `flyr'"
    local step=`step'+1
}
drop expsh85
order niv80 expsh86-expsh89 expsh90-expsh98
local yr 86
while `yr'<=98 {
    replace expsh`yr'=expsh`yr'/100
    local yr=`yr'+1
}
sort niv80
merge niv80 using `ramimp'
drop _merge
order niv80 imppen86-imppen98 expsh86-expsh98
local yr 86
while `yr'<=98 {
    gen effpen`yr'=1/(1+((1-expsh`yr')/imppen`yr'))
    replace effpen`yr'=0 if effpen`yr'==. & imppen`yr'==0
    local flyr=`yr'+1900
    label var effpen`yr' "Effective Penetration in `flyr'"
    local yr=`yr'+1
}
reshape long imppen expsh effpen, i(niv80) j(year)
format year %2.0f
label var year "Calendar Year"
rename imppen rimppen
label var rimppen "Ramos: Imp. Penetr. of Sector"
rename expsh rexpsh
label var rexpsh "Ramos: Export Share in Sector"
rename effpen reffpen
label var reffpen "Ramos: Eff. Penetr. of Sector"
sort niv80 year
merge niv80 year using `penet'
order niv80 indtype year
drop _merge
drop if niv80<200
sort niv80 year
order niv80 indtype year reffpen meffpen rimppen rexpsh mprod mimp mexp
compress
save "brazprod\addl\imp-penetrat", replace


/* Weighting/Reshaping Scheme to Arrive at Annual Tariffs */
/*--------------------------------------------------------*/
/* Currently: Mere Average */
capture program drop weight
program define weight
    args minyr maxyr hdvars
    local yr=`minyr'
    while `yr'<=`maxyr' {
        gen tarif`yr'=(jan`yr' + feb`yr' + mar`yr' + apr`yr' + may`yr' + jun`yr' + jul`yr' + aug`yr' + sep`yr' + oct`yr' + nov`yr' + dec`yr')/12
        local yr=`yr'+1
        }
    keep `hdvars' tarif`minyr'-tarif`maxyr'
    reshape long tarif, i(`hdvars') j(year)
    rename tarif tariff
    label var tariff "Annual Sectoral Tariff"
    label var year "Calendar Year"
end


/* Tariffs */
/*---------*/
/* Note: Nominal tariffs are calculated as annual means using "weight" (above) */
/*       Then monthly real exchange rate weighted tariffs are calculated and
            transformed to annual values using "weight" */
/*       For the effective tariffs, a monthly series of effective tariffs is 
            using he prevailing annual input-output matrix calculated. These
            values are then transformed to annual values using "weight" */
/*       For the real exchange rate weighted effective tariffs, the monthly
            series of real exchange rate weighted tariffs is used (not available 
            as direct output), and then "weight" is applied */


/* Nominal Sectoral Tariffs */
/*--------------------------*/
insheet using "brazprod\addl\kume-nominal.csv", clear
rename nivel80 niv80
gen feb86=jan86
gen mar86=jan86
gen apr86=jan86
gen may86=jan86
gen jun86=jan86
gen jul86=jan86
gen aug86=jan86
gen sep86=jan86
gen oct86=jan86
gen nov86=jan86
gen dec86=jan86
gen jan87=jan86
gen feb87=jan86
gen mar87=jan86
gen apr87=jan86
gen may87=jan86
gen jun87=jan86
gen jul87=jan86
gen aug87=jan86
gen sep87=jan86
gen oct87=jan86
gen nov87=jan86
gen dec87=jan86
gen jan88=jan86
gen feb88=jan86
gen mar88=jan86
gen apr88=jan86
gen may88=jan86
gen jun88=jan86
gen aug88=jul88
gen sep88=jul88
gen oct88=jul88
gen nov88=jul88
gen dec88=jul88
gen jan89=jul88
gen feb89=jul88
gen mar89=jul88
gen apr89=jul88
gen may89=jul88
gen jun89=jul88
gen jul89=jul88
gen aug89=jul88
gen oct89=sep89
gen nov89=sep89
gen dec89=sep89
gen jan90=sep89
gen feb90=sep89
gen mar90=sep89
gen apr90=sep89
gen may90=sep89
gen jun90=sep89
gen jul90=sep89
gen aug90=sep89
gen sep90=sep89
gen oct90=sep89
gen nov90=sep89
gen jan91=dec90
gen mar91=feb91
gen apr91=feb91
gen may91=feb91
gen jun91=feb91
gen jul91=feb91
gen aug91=feb91
gen sep91=feb91
gen oct91=feb91
gen nov91=feb91
gen dec91=feb91
gen feb92=jan92
gen mar92=jan92
gen apr92=jan92
gen may92=jan92
gen jun92=jan92
gen jul92=jan92
gen aug92=jan92
gen sep92=jan92
gen nov92=oct92
gen dec92=oct92
gen jan93=oct92
gen feb93=oct92
gen mar93=oct92
gen apr93=oct92
gen may93=oct92
gen jun93=oct92
gen aug93=jul93
gen sep93=jul93
gen oct93=jul93
gen nov93=jul93
gen dec93=jul93
gen jan94=jul93
gen feb94=jul93
gen mar94=jul93
gen apr94=jul93
gen may94=jul93
gen jun94=jul93
gen jul94=jul93
gen aug94=jul93
gen sep94=jul93
gen oct94=jul93
gen nov94=jul93
gen jan95=dec94
gen feb95=dec94
gen mar95=dec94
gen apr95=dec94
gen may95=dec94
gen jun95=dec94
gen jul95=dec94
gen aug95=dec94
gen sep95=dec94
gen oct95=dec94
gen nov95=dec94
gen jan96=dec95
gen feb96=dec95
gen mar96=dec95
gen apr96=dec95
gen may96=dec95
gen jun96=dec95
gen jul96=dec95
gen aug96=dec95
gen sep96=dec95
gen oct96=dec95
gen nov96=dec95
gen jan97=dec96
gen feb97=dec96
gen mar97=dec96
gen apr97=dec96
gen may97=dec96
gen jun97=dec96
gen jul97=dec96
gen aug97=dec96
gen sep97=dec96
gen oct97=dec96
gen nov97=dec96
gen jan98=dec97
gen feb98=dec97
gen mar98=dec97
gen apr98=dec97
gen may98=dec97
gen jun98=dec97
gen jul98=dec97
gen aug98=dec97
gen sep98=dec97
gen oct98=dec97
gen nov98=dec97
gen jan99=dec98
gen feb99=dec98
gen mar99=dec98
gen apr99=dec98
gen may99=dec98
gen jun99=dec98
gen jul99=dec98
gen aug99=dec98
gen sep99=dec98
gen oct99=dec98
gen nov99=dec98
order niv80 jan86 feb86 mar86 apr86 may86 jun86 jul86 aug86 sep86 oct86 nov86 dec86 jan87 feb87 mar87 apr87 may87 jun87 jul87 aug87 sep87 oct87 nov87 dec87 jan88 feb88 mar88 apr88 may88 jun88 jul88 aug88 sep88 oct88 nov88 dec88 jan89 feb89 mar89 apr89 may89 jun89 jul89 aug89 sep89 oct89 nov89 dec89 jan90 feb90 mar90 apr90 may90 jun90 jul90 aug90 sep90 oct90 nov90 dec90 jan91 feb91 mar91 apr91 may91 jun91 jul91 aug91 sep91 oct91 nov91 dec91 jan92 feb92 mar92 apr92 may92 jun92 jul92 aug92 sep92 oct92 nov92 dec92 jan93 feb93 mar93 apr93 may93 jun93 jul93 aug93 sep93 oct93 nov93 dec93 jan94 feb94 mar94 apr94 may94 jun94 jul94 aug94 sep94 oct94 nov94 dec94 jan95 feb95 mar95 apr95 may95 jun95 jul95 aug95 sep95 oct95 nov95 dec95 jan96 feb96 mar96 apr96 may96 jun96 jul96 aug96 sep96 oct96 nov96 dec96 jan97 feb97 mar97 apr97 may97 jun97 jul97 aug97 sep97 oct97 nov97 dec97 jan98 feb98 mar98 apr98 may98 jun98 jul98 aug98 sep98 oct98 nov98 dec98 jan99 feb99 mar99 apr99 may99 jun99 jul99 aug99 sep99 oct99 nov99 dec99
sort niv80
save `tarifa', replace
compress
save "brazprod\addl\tariffs", replace

set matsize 168
mkmat jan86-dec99, matrix(TAR)
drop jan86-dec99
save `niv80'
drop niv80
matrix TAR=TAR'
svmat double TAR
merge using `reuse'
if _merge[_N]~=3 {error /*matrices do not conform*/}
drop _merge
local i 1
while `i'<=53 {
    replace TAR`i'=TAR`i'*realx
    local i=`i'+1
}
matrix drop TAR
mkmat TAR1-TAR53, matrix(TAR)
matrix TAR=TAR'
drop _all
svmat double TAR
merge using `niv80'
drop _merge
order niv80
local i 1
while `i'<=168 {
  local yr=85+int(`i'/12+(1-1/12))
  if (`i'+11)/12==int((`i'+11)/12) {rename TAR`i' jan`yr'}
  capture label var jan`yr' "Jan-`yr'"
  if (`i'+10)/12==int((`i'+10)/12) {rename TAR`i' feb`yr'}
  capture label var feb`yr' "Feb-`yr'"
  if (`i'+9)/12==int((`i'+9)/12)   {rename TAR`i' mar`yr'}
  capture label var mar`yr' "Mar-`yr'"
  if (`i'+8)/12==int((`i'+8)/12)   {rename TAR`i' apr`yr'}
  capture label var apr`yr' "Apr-`yr'"
  if (`i'+7)/12==int((`i'+7)/12)   {rename TAR`i' may`yr'}
  capture label var may`yr' "May-`yr'"
  if (`i'+6)/12==int((`i'+6)/12)   {rename TAR`i' jun`yr'}
  capture label var jun`yr' "Jun-`yr'"
  if (`i'+5)/12==int((`i'+5)/12)   {rename TAR`i' jul`yr'}
  capture label var jul`yr' "Jul-`yr'"
  if (`i'+4)/12==int((`i'+4)/12)   {rename TAR`i' aug`yr'}
  capture label var aug`yr' "Aug-`yr'"
  if (`i'+3)/12==int((`i'+3)/12)   {rename TAR`i' sep`yr'}
  capture label var sep`yr' "Sep-`yr'"
  if (`i'+2)/12==int((`i'+2)/12)   {rename TAR`i' oct`yr'}
  capture label var oct`yr' "Oct-`yr'"
  if (`i'+1)/12==int((`i'+1)/12)   {rename TAR`i' nov`yr'}
  capture label var nov`yr' "Nov-`yr'"
  if (`i')/12==int((`i')/12)       {rename TAR`i' dec`yr'}
  capture label var dec`yr' "Dec-`yr'"
  local i=`i'+1
}
sort niv80
save `tarifrx', replace

weight 86 99 "niv80"
drop if year==99
sort niv80 year
rename tariff tariffrx
label var tariffrx "Real Exch. Weighted Tariff"
save `reuse', replace
use `tarifa', clear
weight 86 99 "niv80"
drop if year==99
sort niv80 year
merge niv80 year using `reuse'
drop _merge
sort niv80 year
compress
save "brazprod\addl\tariffs-outp", replace


/* Effective Import Tariffs */
/*--------------------------*/

/* Intermediate Goods Tariffs */
/*----------------------------*/
/* Create Temp. Input-Output Matrices */
/* as in prep-deflators.do */
/* Niv80 x Sector (Activity) Weights Matrices, 90-98 */
local yr 90
while `yr'<=98 {
insheet using "brazprod\deflate\contas-nacionais\in-out-`yr'.csv", clear
drop if nivel80==.
drop total
rename nivel80 niv80
local i 2
while `i'<=9 {
    local name=`i'-1
    rename v`i' ativ`name'
    label var ativ`name' "Activity  `name' (NIV80)"
    local i=`i'+1
}
local i 10
while `i'<=32 {
    rename v`i' ativ`i'
    label var ativ`i' "Activity `i' (NIV80)"
    local i=`i'+1
}
drop ativ1 v33-v44
sort niv80
save `inout`yr'', replace
local yr=`yr'+1
}
/* Make matrices 1986-1989 from 1985 and 1990 */
/* Method: W85 + (DIFF/5)*Step = W90 */
insheet using "brazprod\deflate\contas-nacionais\in-out-85-orig.csv", clear
drop if ativ80==.
drop v82
set matsize 85
mkmat v2-v81, matrix(IO85)
matrix input sec=(0101,0102,0103,0104,0105,0106,0107,0108,0109,0110,0199,0201,0202,0301,0302,0401,0501,0502,0601,0701,0801,0802,1001,1101,1201,1301,1401,1501,1601,1701,1702,1801,1802,1803,1804,1805,1806,1901,1902,1903,2001,2101,2201,2202,2203,2204,2205,2301,2401,2501,2601,2602,2603,2701,2702,2801,2802,2901,3001,3002,3101,3102,3201,3301,3401,3501,3601,3701,3801,3802,3901,3902,3903,4001,4101,4102,4201,4202,4203,4301)
matrix IO85=sec' , IO85'
drop _all
svmat double IO85
matrix drop IO85 sec
rename IO851 niv80
label var niv80 "NIVEL 80"
local i 2
while `i'<=9 {
    local name=`i'-1
    rename IO85`i' start`name'
    label var start`name' "Activity  `name' (NIV80)"
    local i=`i'+1
}
while `i'<=43 {
    rename IO85`i' start`i'
    label var start`i' "Activity `i' (NIV80)"
    local i=`i'+1
}
rename IO8544 start46
label var start46 "46"
sort niv80
drop start1 start33-start46
merge niv80 using `inout90'
drop _merge
local i 2
while `i'<=32 {
    if `i'==9 {local i 10}
    quietly egen tot`i'=sum(ativ`i')
    replace ativ`i'=ativ`i'/tot`i'
    drop tot`i'
    quietly egen tot`i'=sum(start`i')
    replace start`i'=start`i'/tot`i'
    drop tot`i'
    local i=`i'+1
}
local step 1
while `step'<=4 {
    local i 2
    while `i'<=32 {
        if `i'==9 {local i 10}
        gen new`i'=start`i'+`step'*((ativ`i'-start`i')/5)
        local i=`i'+1
    }
preserve
    local yr=`step'+85
    keep niv80 new2-new32
    local i 2
    while `i'<=32 {
        if `i'==9 {local i 10}
        rename new`i' ativ`i'
        if `i'<10 {label var ativ`i' "Activity  `i' (NIV80)"}
            else {label var ativ`i' "Activity `i' (NIV80)"}
        local i=`i'+1
    }
    sort niv80
    save `inout`yr'', replace
restore
drop new2-new32
local step=`step'+1
}

/* (Niv80 x 1)-Tariffs Matrix */
local tfile 1
while `tfile'<=2 {
use "brazprod\filters\niv10080", clear
sort niv100
merge niv100 using "brazprod\deflate\comp-defl"   /* Read-in indtype */
keep niv80 niv100 nivmap indtype
sort niv80
if `tfile'==1 {merge niv80 using `tarifa'}
if `tfile'==2 {merge niv80 using `tarifrx'}
keep if _merge==3    /* Keep Only if Tariff for Sector Exists */
drop _merge
keep if jan86~=.
keep niv80 jan86-dec98
sort niv80
quietly by niv80: keep if _n==1
label var niv80 "NIVEL 80"
order niv80 jan86-dec98
sort niv80
save `master', replace

/* Merge data, create & multiply matrices */
local yr 86
while `yr'<=98 {
use `inout`yr'', clear
merge niv80 using `master'
keep if _merge==3
drop _merge
local i 2
while `i'<=32 {
    if `i'==9 {local i 10}
    quietly egen tot`i'=sum(ativ`i')
    replace ativ`i'=ativ`i'/tot`i'
    drop tot`i'
    local i=`i'+1
}
sort niv80
mkmat ativ2-ativ32, matrix(W)
mkmat jan`yr'-dec`yr', matrix(M)
matrix DEFL=W'*M
matrix drop W M
matrix input ativ = (2,3,4,5,6,7,8,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32)
matrix DEFL = ativ' , DEFL
drop niv80 ativ2-ativ32 jan86-dec98
svmat double DEFL, names(col)
gen byte ativ80=r1
drop r1
format ativ80 %2.0f
label var ativ80 "Activity (NIV80 Ativ.)"
label var jan`yr' "Jan-`yr'"
label var feb`yr' "Feb-`yr'"
label var mar`yr' "Mar-`yr'"
label var apr`yr' "Apr-`yr'"
label var may`yr' "May-`yr'"
label var jun`yr' "Jun-`yr'"
label var jul`yr' "Jul-`yr'"
label var aug`yr' "Aug-`yr'"
label var sep`yr' "Sep-`yr'"
label var oct`yr' "Oct-`yr'"
label var nov`yr' "Nov-`yr'"
label var dec`yr' "Dec-`yr'"
sort ativ80
save `intrf`yr'', replace
local yr=`yr'+1
}
use `intrf86', replace
local yr 87
while `yr'<=98  {
    merge using `intrf`yr''
    drop _merge
    local yr=`yr'+1
}
preserve
    use "brazprod\filters\niv10080", clear
    gen byte ativ80=int(niv80/100)
    keep ativ80 niv100
    sort niv100
    quietly by niv100: keep if _n==1
    sort ativ80
    format ativ80 %2.0f
    format niv100 %4.0f
    label var niv100 "Sector of Firm (NIV100)"
    label var ativ80 "Activity (NIV80 Ativ.)"
    save `tmp', replace
restore
joinby ativ80 using `tmp'
order ativ80 niv100
compress
if `tfile'==1 { save "brazprod\addl\tariffs-intm-monthly", replace }
weight 86 98 "ativ80 niv100"
order ativ80 niv100
sort ativ80 niv100 year
if `tfile'==1 {
    save `reuse1', replace
}
if `tfile'==2 {
    rename tariff tariffrx
    label var tariffrx "Real Exch. Weighted Tariff"
    save `reuse2', replace
}
local tfile=`tfile'+1
}
use `reuse2', clear
merge ativ80 niv100 year using `reuse1'
order ativ80 niv100 year tariff tariffrx
drop _merge
sort ativ80 year
compress
save "brazprod\addl\tariffs-intm", replace


/* Capital Goods Tariffs */
/*-----------------------*/
/* Create Temp. Capital Formation Vectors */
/* as in prep-deflators.do */
/* Niv80 x Capital Formation Vector (for all industries), 90-98 */
local yr 90
while `yr'<=98 {
insheet using "brazprod\deflate\contas-nacionais\cap-form-`yr'.csv", clear
drop if nivel80==.
rename nivel80 niv80
rename capitalf capform
label var capform "Capital Formation"
sort niv80
drop if niv80==9999
save `capf`yr'', replace
local yr=`yr'+1
}
/* Make vectors 1986-1989 from 1985 and 1990 */
/* Method: W85 + (DIFF/5)*Step = W90 */
insheet using "brazprod\deflate\contas-nacionais\cap-form-85.csv", clear
drop if nivel80==9999
drop if nivel80==.
rename nivel80 niv80
rename capital start
sort niv80
merge niv80 using `capf90'
drop _merge
    quietly egen tot=sum(capform)
    replace capform=capform/tot
    drop tot
    quietly egen tot=sum(start)
    replace start=start/tot
    drop tot
local step 1
while `step'<=4 { 
gen new=start+`step'*((capform-start)/5)
preserve
    local yr=`step'+85
    keep niv80 new
    rename new capform
    label var capform "Share in Capital Formation"
    sort niv80
    save `capf`yr'', replace
restore
drop new
local step=`step'+1
}

/* (Niv80 x 1)-Tariffs Matrix */
local tfile 1
while `tfile'<=2 {
use "brazprod\filters\niv10080", clear
sort niv100
merge niv100 using "brazprod\deflate\comp-defl"   /* Read-in indtype */
keep niv80 niv100 nivmap indtype
sort niv80
if `tfile'==1 {merge niv80 using `tarifa'}
if `tfile'==2 {merge niv80 using `tarifrx'}
keep if _merge==3    /* Keep Only if Tariff for Sector Exists */
drop _merge
keep if jan86~=.
keep niv80 jan86-dec98
sort niv80
quietly by niv80: keep if _n==1
label var niv80 "NIVEL 80"
order niv80 jan86-dec98
sort niv80
save `master', replace

/* Merge data & create capital goods tariffs */
local round 1
/* Round 1: Total, 2: Machinery, 3: Vehicles, 4: Computers, 5: Other */
while `round'<=5 {
local yr 86
while `yr'<=98 {
use `capf`yr'', clear
if `round'==2 {replace capform=0 if (niv80~=701 & niv80~=801 & niv80~=802 & niv80~=1001 & niv80~=1101)}  /* Machinery */
if `round'==3 {replace capform=0 if (niv80~=1201 & niv80~=1301)}  /* Vehicles */
if `round'==4 {replace capform=0 if (niv80~=1101)}  /* Computers */
if `round'==5 {replace capform=0 if (niv80~=199 & niv80~=401 & niv80~=1401 & niv80~=1501 & niv80~=2205 & niv80~=3201)}  /* Other */
sort niv80
merge niv80 using `master'
keep if _merge==3
drop _merge
    quietly egen tot=sum(capform)
    replace capform=capform/tot
    drop tot
gen nwjan`yr'=jan`yr'*capform
gen nwfeb`yr'=feb`yr'*capform
gen nwmar`yr'=mar`yr'*capform
gen nwapr`yr'=apr`yr'*capform
gen nwmay`yr'=may`yr'*capform
gen nwjun`yr'=jun`yr'*capform
gen nwjul`yr'=jul`yr'*capform
gen nwaug`yr'=aug`yr'*capform
gen nwsep`yr'=sep`yr'*capform
gen nwoct`yr'=oct`yr'*capform
gen nwnov`yr'=nov`yr'*capform
gen nwdec`yr'=dec`yr'*capform
drop jan`yr'-dec`yr'
egen jan`yr'=sum(nwjan`yr')
egen feb`yr'=sum(nwfeb`yr')
egen mar`yr'=sum(nwmar`yr')
egen apr`yr'=sum(nwapr`yr')
egen may`yr'=sum(nwmay`yr')
egen jun`yr'=sum(nwjun`yr')
egen jul`yr'=sum(nwjul`yr')
egen aug`yr'=sum(nwaug`yr')
egen sep`yr'=sum(nwsep`yr')
egen oct`yr'=sum(nwoct`yr')
egen nov`yr'=sum(nwnov`yr')
egen dec`yr'=sum(nwdec`yr')
keep niv80 jan`yr' feb`yr' mar`yr' apr`yr' may`yr' jun`yr' jul`yr' aug`yr' sep`yr' oct`yr' nov`yr' dec`yr'
format niv80 %4.0f
label var niv80 "NIVEL 80"
label var jan`yr' "Jan-`yr'"
label var feb`yr' "Feb-`yr'"
label var mar`yr' "Mar-`yr'"
label var apr`yr' "Apr-`yr'"
label var may`yr' "May-`yr'"
label var jun`yr' "Jun-`yr'"
label var jul`yr' "Jul-`yr'"
label var aug`yr' "Aug-`yr'"
label var sep`yr' "Sep-`yr'"
label var oct`yr' "Oct-`yr'"
label var nov`yr' "Nov-`yr'"
label var dec`yr' "Dec-`yr'"
format jan`yr' feb`yr' mar`yr' apr`yr' may`yr' jun`yr' jul`yr' aug`yr' sep`yr' oct`yr' nov`yr' dec`yr' %10.0g  
drop niv80
keep if _n==1
if `round'==1 {gen str10 captype="total"}
if `round'==2 {gen str10 captype="machinery"}
if `round'==3 {gen str10 captype="vehicles"}
if `round'==4 {gen str10 captype="computers"}
if `round'==5 {gen str10 captype="other"}
label var captype "Type of Capital"
order captype jan`yr' feb`yr' mar`yr' apr`yr' may`yr' jun`yr' jul`yr' aug`yr' sep`yr' oct`yr' nov`yr' dec`yr'
save `intrf`yr'', replace
local yr=`yr'+1
}
use `intrf86', replace
local yr 87
while `yr'<=98  {
    merge using `intrf`yr''
    drop _merge
    local yr=`yr'+1
}
save `cap`round'', replace
local round=`round'+1
}
use `cap1', clear
append using `cap2'
append using `cap3'
append using `cap4'
append using `cap5'
sort captype
compress
gen byte _srtno = 1 if captype=="total"
replace  _srtno = 2 if captype=="machinery"
replace  _srtno = 3 if captype=="vehicles"
replace  _srtno = 4 if captype=="computers"
replace  _srtno = 5 if captype=="other"
sort _srtno
drop _srtno
compress
if `tfile'==1 { save "brazprod\addl\tariffs-cap-monthly", replace }
weight 86 98 "captype"
sort captype year
if `tfile'==1 {
    save `reuse1', replace
}
if `tfile'==2 {
    rename tariff tariffrx
    label var tariffrx "Real Exch. Weighted Tariff"
    save `reuse2', replace
}
local tfile=`tfile'+1
}
use `reuse2', clear
merge captype year using `reuse1'
order captype year tariff tariffrx
drop _merge
sort captype year
compress
gen byte _srtno = 1 if captype=="total"
replace  _srtno = 2 if captype=="machinery"
replace  _srtno = 3 if captype=="vehicles"
replace  _srtno = 4 if captype=="computers"
replace  _srtno = 5 if captype=="other"
sort _srtno year
drop _srtno
compress
save "brazprod\addl\tariffs-cap", replace

matrix drop DEFL ativ TAR SER
