version 7
set matsize 200

/* Trading partners' price levels */

foreach country in "argentina" "chile" "italy" "japan" "mexico" "singapur" "taiwan" "uruguay" "venezuela" {
local lccntry=lower("`country'")
local file = "brazprod/addl/ivs/findata/WPI/" + "`lccntry'.csv"
insheet using "`file'", clear
quietly keep date close
quietly drop if close==.
rename close `lccntry'
quietly replace date = substr(date,-4,4)
gen int year=int(real(date))
quietly drop date
order year `lccntry'
label var year "Calendar Year"
local varlab="`country': WPI"
local varlab=upper(substr("`varlab'",1,1))+substr("`varlab'",2,length("`varlab'")-1)
label var `lccntry' "`varlab'"
quietly drop if year>2000
sort year
tempfile `lccntry'
save ``lccntry''
}
foreach country in "belgium" "canada" "france" "germany" "korea" "netherlands" "spain" "sweden" "switzerland" "UK" "USA" {
local lccntry=lower("`country'")
local file = "brazprod/addl/ivs/findata/PPI/" + "`lccntry'.csv"
insheet using "`file'", clear
quietly keep date close
quietly drop if close==.
rename close `lccntry'
quietly replace date = substr(date,-4,4)
gen int year=int(real(date))
quietly drop date
order year `lccntry'
label var year "Calendar Year"
local varlab="`country': PPI"
local varlab=upper(substr("`varlab'",1,1))+substr("`varlab'",2,length("`varlab'")-1)
label var `lccntry' "`varlab'"
quietly drop if year>2000
sort year
tempfile `lccntry'
save ``lccntry''
}
foreach country in "china" "hongKong" "panama" "paraguay" "saudiArabia" {
local lccntry=lower("`country'")
local file = "brazprod/addl/ivs/findata/CPI/" + "`lccntry'.csv"
insheet using "`file'", clear
quietly keep date close
quietly drop if close==.
rename close `lccntry'
quietly replace date = substr(date,-4,4)
gen int year=int(real(date))
quietly drop date
order year `lccntry'
label var year "Calendar Year"
local varlab="`country': CPI"
local varlab=upper(substr("`varlab'",1,1))+substr("`varlab'",2,length("`varlab'")-1)
label var `lccntry' "`varlab'"
quietly drop if year>2000
sort year
tempfile `lccntry'
save ``lccntry''
}

use `argentina', clear
foreach country in "belgium" "canada" "chile" "china" "france" "germany" "hongkong" "italy" "japan" "korea" "mexico" "netherlands" "panama" "paraguay" "saudiarabia" "singapur" "spain" "sweden" "switzerland" "taiwan" "uk" "uruguay" "usa" "venezuela" {
sort year
merge year using ``country''
drop _merge
}
sort year

/* Rebase all years so that 1995 == 1 */

foreach country in "argentina" "belgium" "canada" "chile" "china" "france" "germany" "hongkong" "italy" "japan" "korea" "mexico" "netherlands" "panama" "paraguay" "saudiarabia" "singapur" "spain" "sweden" "switzerland" "taiwan" "uk" "uruguay" "usa" "venezuela" {
    quietly gen _keyyr = `country'[12]  /* 1995 */
    qui replace `country'=`country'/_keyyr
    drop _keyyr
}

compress
save "brazprod/addl/ivs/findata/world-wpi-cpi-ppi", replace
