/* Routines for Use with olley-pakes-bstrp.do */
version 7.0

/* Choose Settings */
/*-----------------*/

global trd 0
/* Choice 3: Klette & Griliches 96 correction */
/* Choice 2: year dummies ON, trend variables OFF */
/* Choice 1: trend variables ON, time dummies OFF  */
/* Choice 0: trend variables and year dummies OFF */
if $trd==3 {local trdtype "kletgri"}
if $trd==2 {local trdtype "dyears"}
if $trd==1 {local trdtype "trend"}
if $trd==0 {local trdtype "notrend"}


/* Combining Olley-Pakes steps 1 and 3 to one estimation command */
/*---------------------------------------------------------------*/
capture program drop bsop13
program define bsop13
    version 7.0
    if "`1'" == "?" {
        global S_1 "kappa lnk lnq mu lnintm lnlabfwh lnlabfbl ntkinv ntqinv lnage klegri reffpen tariff olp olnk kklegri kreffp ktarif kxolp ntkxok qklegri qreffp qtarif qxolp ntqxok"
        exit
    }
    
    tempvar lefths dummy

    /* Starting Values */
    if $trd==3 {
        if $out==1 {local rvars "lnvaladd kappa1 lnapk1 lnapq1 lnlabfbl lnlabfwh kletgril"
                    local tstvars "lnapk1 + lnapq1 + lnlabfbl + lnlabfwh = 1"}
        if $out==2 {local rvars "lnoutput kappa1 lnapk1 lnapq1 lnlabfbl lnlabfwh mu lnintmed kletgri"
                    local tstvars "lnapk1 + lnapq1 + lnlabfbl + lnlabfwh + lnintmed = 1"}
    }
    if $trd==2 {
        if $out==1 {local rvars "lnvaladd kappa1 lnapk1 lnapq1 lnlabfbl lnlabfwh dyr87-dyr98"
                    local tstvars "lnapk1 + lnapq1 + lnlabfbl + lnlabfwh = 1"}
        if $out==2 {local rvars "lnoutput kappa1 lnapk1 lnapq1 lnlabfbl lnlabfwh mu lnintmed dyr87-dyr98"
                    local tstvars "lnapk1 + lnapq1 + lnlabfbl + lnlabfwh + lnintmed = 1"}
    }
    if $trd==1 {
        if $out==1 {local rvars "lnvaladd kappa1 lnapk1 lnapq1 lnlabfbl lnlabfwh trend*"
                    local tstvars "lnapk1 + lnapq1 + lnlabfbl + lnlabfwh = 1"}
        if $out==2 {local rvars "lnoutput kappa1 lnapk1 lnapq1 lnlabfbl lnlabfwh mu lnintmed trend*"
                    local tstvars "lnapk1 + lnapq1 + lnlabfbl + lnlabfwh + lnintmed = 1"}
    }
    if $trd==0 {
        if $out==1 {local rvars "lnvaladd kappa1 lnapk1 lnapq1 lnlabfbl lnlabfwh"
                    local tstvars "lnapk1 + lnapq1 + lnlabfbl + lnlabfwh = 1"}
        if $out==2 {local rvars "lnoutput kappa1 lnapk1 lnapq1 lnlabfbl lnlabfwh mu lnintmed"
                    local tstvars "lnapk1 + lnapq1 + lnlabfbl + lnlabfwh + lnintmed = 1"}
    }
   reg1bstr "`rvars'" "group==$grp" "`tstvars'"

   /* OP Step 2 */
   if $trd==3 {
       if $out==1 {local rvars "lnvaladd lnlabfbl lnlabfwh kappa1 lnapk1 lnapq1 ntkinv ntqinv lnage kletgril _p*"}
       if $out==2 {local rvars "lnoutput lnlabfbl lnlabfwh mu lnintm kappa1 lnapk1 lnapq1 ntkinv ntqinv lnage kletgril _p*"}
       }
   if $trd==2 {
       if $out==1 {local rvars "lnvaladd lnlabfbl lnlabfwh kappa1 lnapk1 lnapq1 ntkinv ntqinv lnage dyr87-dyr98 _p*"}
       if $out==2 {local rvars "lnoutput lnlabfbl lnlabfwh mu lnintm kappa1 lnapk1 lnapq1 ntkinv ntqinv lnage dyr87-dyr98 _p*"}
       }
   if $trd==1 {
       if $out==1 {local rvars "lnvaladd lnlabfbl lnlabfwh kappa1 lnapk1 lnapq1 ntkinv ntqinv lnage trend* _p*"}
       if $out==2 {local rvars "lnoutput lnlabfbl lnlabfwh mu lnintm kappa1 lnapk1 lnapq1 ntkinv ntqinv lnage trend* _p*"}
       }
   if $trd==0 {
       if $out==1 {local rvars "lnvaladd lnlabfbl lnlabfwh kappa1 lnapk1 lnapq1 ntkinv ntqinv lnage _p*"}
       if $out==2 {local rvars "lnoutput lnlabfbl lnlabfwh mu lnintm kappa1 lnapk1 lnapq1 ntkinv ntqinv lnage _p*"}
       }
   if $fe==1 { ollpak1x "`rvars'" "group==$grp" }
   else      { ollpak1 "`rvars'" "group==$grp" }
   matrix beta=e(b)
   * set globals instead of outstp1
   * ($mu) ($lnintm) ($lnlabfwh) ($lnlabfbl) ($ntkinv) ($ntqinv) ($lnage) ($klegri) ($reffpen) ($tariff) ($olp)     ($olnk)    ($kklegri) ($kreffp) ($ktarif) ($kxolp) ($ntkxok) ($qklegri) ($qreffp) ($qtarif) ($qxolp) ($ntqxok)
   * mu    lnintm    lnlabfwh    lnlabfbl    ntkinv    ntqinv    lnage    kletgril  reffpen    tariff    oth_lpprox oth_lnapk1 kklegri    kreffp    ktarif    kxolp    ntkxok    qklegri    qreffp    qtarif    qxolp    ntqxok
   *                                                                      _p890    _p891       _p892     _p893      _p894      _p701      _p702     _p703     _p704    _p705     _p706      _p707     _p708     _p709    _p710 
   global lnlabfwh= _b[lnlabfwh]
   global lnlabfbl= _b[lnlabfbl]
   global ntkinv  = _b[ntkinv]
   global ntqinv  = _b[ntqinv]
   global lnage   = _b[lnage]
   if $xeff == 1 {
    global klegri  = _b[_p890]
    global reffpen = _b[_p891]
    global tariff  = _b[_p892]
    global olp     = _b[_p893]
    global olnk    = _b[_p894]
    global kklegri = _b[_p701]
    global kreffp  = _b[_p702]
    global ktarif  = _b[_p703]
    global kxolp   = _b[_p704]
    global ntkxok  = _b[_p705]
    global qklegri = _b[_p706]
    global qreffp  = _b[_p707]
    global qtarif  = _b[_p708]
    global qxolp   = _b[_p709]
    global ntqxok  = _b[_p710]
    }
   else {
    global klegri  = .
    global reffpen = .
    global tariff  = .
    global olp     = .
    global olnk    = .
    global kklegri = .
    global kreffp  = .
    global ktarif  = .
    global kxolp   = .
    global ntkxok  = .
    global qklegri = .
    global qreffp  = .
    global qtarif  = .
    global qxolp   = .
    global ntqxok  = .
    }
   if $out==1 { gen `lefths' = lnvaladd - _b[lnlabfbl]*lnlabfbl - _b[lnlabfwh]*lnlabfwh if group==$grp }
   if $out==2 { global lnintm = _b[lnintm]
                global mu = _b[mu]
                local dof=e(df_r)
                gen `lefths' = lnoutput - _b[lnlabfbl]*lnlabfbl - _b[lnlabfwh]*lnlabfwh - _b[lnintm]*lnintmed if group==$grp
                if ttail(`dof',abs(_b[mu]/_se[mu]))*2 <= .05 {replace `lefths' = `lefths' - beta[1,3]*mu if group==$grp}
                }
   if $fe==1  { replace `lefths' = `lefths' - betafe if group==$grp }
   matrix drop beta
   sort firm year
   quietly by firm: replace phihat0=`lefths'[_n-1] if year~=92 & group==$grp
   egen `dummy'=mean(`lefths') if year>=89 & year<=92 & group==$grp, by(firm)
   replace phihat0=`dummy' if year==92 & group==$grp

   /* OP Step 3. Production Function */
   keep firm year group `lefths' kappa* lnapk* lnapq* phihat0 _prhat* ${trdvar}
   capture quietly drop _dpart*
   foreach i in 0 1 2 3 4 5 6 7 { gen _dpart`i'=0 }
   if e(N)~=. {  /* First stage must have worked */
       if $trd==1 { nlmam bstr3 `lefths' kappa1 kappa0 lnapk1 lnapk0 lnapq1 lnapq0 phihat0 _prhat1 _prhat2 _prhat3 _prhat4 _prhat5 _prhat6 trend1 trend2 trend3 if group==$grp, iterate($maxiter) eps(`eps') }
       else       { nlmam bstr3 `lefths' kappa1 kappa0 lnapk1 lnapk0 lnapq1 lnapq0 phihat0 _prhat1 _prhat2 _prhat3 _prhat4 _prhat5 _prhat6 if group==$grp, iterate($maxiter) eps(`eps') }
       }

   post `1' ($bkappa) ($bk) ($bq) ($mu) ($lnintm) ($lnlabfwh) ($lnlabfbl) ($ntkinv) ($ntqinv) ($lnage) ($klegri) ($reffpen) ($tariff) ($olp) ($olnk) ($kklegri) ($kreffp) ($ktarif) ($kxolp) ($ntkxok) ($qklegri) ($qreffp) ($qtarif) ($qxolp) ($ntqxok)

end


/* Changed NLS regression for Bootstrap (for use with NLMAM) */
/*-----------------------------------------------------------*/
capture program drop nlbstr3
program define nlbstr3
    version 6.0
    if "`1'" == "?" {
        if $trd==1 {
            /* Up to 2nd order polynomials. Also correct code below. */
            if $polynl==2 {global S_01 "bkappa bk bq b00 b01 b02 b10 b11 b12 b20 b21 b22 btrd1 btrd2 btrd3"}
            /* Up to 3rd order polynomials. Also correct code below. */
            if $polynl==3 {global S_01 "bkappa bk bq b00 b01 b02 b03 b10 b11 b12 b13 b20 b21 b22 b23 b30 b31 b32 b33 btrd1 btrd2 btrd3"}
            /* Up to 4th order polynomials. Also correct code below. */
            if $polynl==4 {global S_01 "bkappa bk bq b00 b01 b02 b03 b04 b10 b11 b12 b13 b14 b20 b21 b22 b23 b24 b30 b31 b32 b33 b34 b40 b41 b42 b43 b44 btrd1 btrd2 btrd3"}
            /* Up to 5th order polynomials. Also correct code below. */
            if $polynl==5 {global S_01 "bkappa bk bq b00 b01 b02 b03 b04 b05 b10 b11 b12 b13 b14 b15 b20 b21 b22 b23 b24 b25 b30 b31 b32 b33 b34 b35 b40 b41 b42 b43 b44 b45 b50 b51 b52 b53 b54 b55 btrd1 btrd2 btrd3"}
            /* Up to 6th order polynomials. Also correct code below. */
            if $polynl==6 {global S_01 "bkappa bk bq b00 b01 b02 b03 b04 b05 b06 b10 b11 b12 b13 b14 b15 b16 b20 b21 b22 b23 b24 b25 b26 b30 b31 b32 b33 b34 b35 b36 b40 b41 b42 b43 b44 b45 b46 b50 b51 b52 b53 b54 b55 b56 b60 b61 b62 b63 b64 b65 b66 btrd1 btrd2 btrd3"}
            }
        else {
            /* Up to 2nd order polynomials. Also correct code below. */
            if $polynl==2 {global S_01 "bkappa bk bq b00 b01 b02 b10 b11 b12 b20 b21 b22"}
            /* Up to 3rd order polynomials. Also correct code below. */
            if $polynl==3 {global S_01 "bkappa bk bq b00 b01 b02 b03 b10 b11 b12 b13 b20 b21 b22 b23 b30 b31 b32 b33"}
            /* Up to 4th order polynomials. Also correct code below. */
            if $polynl==4 {global S_01 "bkappa bk bq b00 b01 b02 b03 b04 b10 b11 b12 b13 b14 b20 b21 b22 b23 b24 b30 b31 b32 b33 b34 b40 b41 b42 b43 b44"}
            /* Up to 5th order polynomials. Also correct code below. */
            if $polynl==5 {global S_01 "bkappa bk bq b00 b01 b02 b03 b04 b05 b10 b11 b12 b13 b14 b15 b20 b21 b22 b23 b24 b25 b30 b31 b32 b33 b34 b35 b40 b41 b42 b43 b44 b45 b50 b51 b52 b53 b54 b55"}
            /* Up to 6th order polynomials. Also correct code below. */
            if $polynl==6 {global S_01 "bkappa bk bq b00 b01 b02 b03 b04 b05 b06 b10 b11 b12 b13 b14 b15 b16 b20 b21 b22 b23 b24 b25 b26 b30 b31 b32 b33 b34 b35 b36 b40 b41 b42 b43 b44 b45 b46 b50 b51 b52 b53 b54 b55 b56 b60 b61 b62 b63 b64 b65 b66"}
            }
        global S_2 "Olley&Pakes 96: Step 3"
        global bkappa=$inikap
        global bk=$inik
        global bq=$iniq
        forvalues i = 0(1)$polynl {
            forvalues j = 0(1)$polynl {
                global b`i'`j'=0
                }
            }
        if $iniols==2 {
            capture quietly drop _nlini*            
            foreach i in 1 2 3 4 5 6 {quietly gen _nlini`i'0=(`8'-$bkappa*`3'-$bk*`5'-$bq*`7')^`i'      if e(sample)}
            foreach i in 1 2 3 4 5 6 {quietly gen _nlini`i'1=(`8'-$bkappa*`3'-$bk*`5'-$bq*`7')^`i'*`9'  if e(sample)}
            foreach i in 1 2 3 4 5 6 {quietly gen _nlini`i'2=(`8'-$bkappa*`3'-$bk*`5'-$bq*`7')^`i'*`10' if e(sample)}
            foreach i in 1 2 3 4 5 6 {quietly gen _nlini`i'3=(`8'-$bkappa*`3'-$bk*`5'-$bq*`7')^`i'*`11' if e(sample)}
            foreach i in 1 2 3 4 5 6 {quietly gen _nlini`i'4=(`8'-$bkappa*`3'-$bk*`5'-$bq*`7')^`i'*`12' if e(sample)}
            foreach i in 1 2 3 4 5 6 {quietly gen _nlini`i'5=(`8'-$bkappa*`3'-$bk*`5'-$bq*`7')^`i'*`13' if e(sample)}
            foreach i in 1 2 3 4 5 6 {quietly gen _nlini`i'6=(`8'-$bkappa*`3'-$bk*`5'-$bq*`7')^`i'*`14' if e(sample)}
            if $polynl==6 {quietly reg `e(depvar)' `2' `4' `6' `9' `10' `11' `12' `13' `14' _nlini* if e(sample)}
            if $polynl==5 {quietly reg `e(depvar)' `2' `4' `6' `9' `10' `11' `12' `13'      _nlini10-_nlini50 _nlini11-_nlini51 _nlini12-_nlini52 _nlini13-_nlini53 _nlini14-_nlini54 _nlini15-_nlini55 if e(sample)}
            if $polynl==4 {quietly reg `e(depvar)' `2' `4' `6' `9' `10' `11' `12'           _nlini10-_nlini40 _nlini11-_nlini41 _nlini12-_nlini42 _nlini13-_nlini43 _nlini14-_nlini44 if e(sample)}
            if $polynl==3 {quietly reg `e(depvar)' `2' `4' `6' `9' `10' `11'                _nlini10-_nlini30 _nlini11-_nlini31 _nlini12-_nlini32 _nlini13-_nlini33 if e(sample)}
            if $polynl<3  {quietly reg `e(depvar)' `2' `4' `6' `9' `10'                     _nlini10-_nlini20 _nlini11-_nlini21 _nlini12-_nlini22 if e(sample)}
            global b00=_b[_cons]
            global b01=  _b[`9']
            global b02= _b[`10']
            if $polynl>=3 {global b03= _b[`11']}
            if $polynl>=4 {global b04= _b[`12']}
            if $polynl>=5 {global b05= _b[`13']}
            if $polynl>=6 {global b06= _b[`14']}
            local i=1
            while `i' <= $polynl {
                local j=0
                while `j' <=$polynl {
                global b`i'`j'=_b[_nlini`i'`j']
                local j=`j'+1                                
                }
            local i=`i'+1
            }
            quietly drop _nlini*            
        }
        global btrd1=.05
        global btrd2=.05
        global btrd3=.05
        exit
    }
    erplc${polynl}${trd} _lefths kappa1 kappa0 lnapk1 lnapk0 lnapq1 lnapq0 phihat0 _prhat1 _prhat2 _prhat3 _prhat4 _prhat5 _prhat6 trend1 trend2 trend3
    replace `1'= _dpart0 + _dpart1 + _dpart2 + _dpart3 + _dpart4 + _dpart5 + _dpart6 + _dpart7
end


/* OLS/FE regressions for starting values */
/*----------------------------------------*/
* excreg1 in olley-pakes.do
capture program drop reg1bstr
program define reg1bstr
    args vars cond test
    if $iniols==1 {
        regress `vars' if `cond'
        matrix beta=e(b)
        global  inikap = beta[1,1]
        global  inik   = beta[1,2]
        global  iniq   = beta[1,3]
        }
    if $iniols==0 | $iniols==2 {
        xtreg `vars' if `cond', fe
        matrix beta=e(b)
        global  inikap = beta[1,1]
        global  inik   = beta[1,2]
        global  iniq   = beta[1,3]
        }
end


/* Output of step 1 results */
/* ------------------------ */
* outstp1 in olley-pakes.do
capture program drop bsstp1
program define bsstp1
    args grp nivdsp
end
